DECLARE SUB printt (A!, b!, C!)
DECLARE SUB aaa ()
DECLARE SUB CMDR (cmd1!, arg!)
DECLARE FUNCTION op6502i! (A!)
DECLARE FUNCTION word! (A!)
DECLARE SUB WORDS (A!, b!)
DECLARE SUB M.LDWORD (A!)
DECLARE FUNCTION op6502! (A!)
DECLARE SUB M.CMP (A!, b!)
DECLARE SUB cmdc (A!, b!)
DECLARE SUB Wr6502 (A&, b!)
DECLARE SUB CMDD (A!, b!)
DECLARE FUNCTION nop6502! (A!)
DECLARE SUB io_write (A!, b!)
DECLARE SUB BANK.SET (A!, b!)
DECLARE SUB T_INIT (A&, b&, C&)
DECLARE FUNCTION Rd6502! (q&)
DECLARE FUNCTION MCZp! ()
DECLARE FUNCTION RAMG! (A!)
DECLARE FUNCTION MCZx! ()
DECLARE SUB REGINC (A!)
DECLARE SUB M.JR ()
DECLARE SUB endprog ()
DECLARE FUNCTION notb! (A!)
DECLARE FUNCTION cmd1! (A!)
DECLARE FUNCTION CMD2! (A!)
DECLARE FUNCTION cmr1! (A!)
DECLARE FUNCTION CMr2! (A!)
CONST MNUL = 0, minc = 1, MDEC = 2, MROR = 3, MROL = 4, MLSR = 5, masl = 6, MTRB = 7, MTSB = 8
CONST M.NUL = 0, m.inc = 1, M.DEC = 2, M.ROR = 3, M.ROL = 4, M.LSR = 5, m.asl = 6, TRB = 7, TSB = 8
CONST m.adc = 9, m.and = 10, m.andx = 11, m.bit = 12, m.eor = 13, m.eorx = 14
CONST m.fl = 15, m.ora = 16, m.orax = 17, m.pop = 18, m.push = 19, M.RMB = 20
CONST mm.zx = 21, MM.Zp = 22, mm.ax = 23, MM.Ab = 24
CONST mr.ab = 25, mr.ax = 26, mr.ay = 27, mr.id = 28, mr.im = 29, mr.ix = 30, mr.iy = 31, mr.zp = 32, mr.zx = 33, mr.zy = 34
CONST mw.ab = 35, mw.ax = 36, mw.ay = 37, mw.ix = 38, mw.iy = 39, mw.zp = 40, mw.zx = 41, mw.zy = 42
CONST m.sbc = 43
CONST M.SMB = 44
CONST m.adcx = 45
CONST mc.ab = 46, mc.ax = 47, mc.ay = 48, mc.id = 49, mc.ix = 50, mc.iy = 51, mc.zp = 52, mc.zx = 53, mc.zy = 54
CONST m.pop.p = 55, m.push.p = 56
DIM SHARED iop, cycles(255), cmdset1(255), cmdset2(255), reg.mpr(8)
DIM SHARED cmd, cmdf

OPEN "cmdd" FOR OUTPUT AS #1


FOR iop = 0 TO 255
cmd = 0: cmdf = 0
aaa
IF cmd > 1 THEN r = r + 1
IF cmdf > 1 THEN cmd = 0

IF cmd <> 0 THEN p = p + 1
printt iop, cmd, 0

NEXT iop

PRINT

CLOSE #1

SUB aaa ()
SELECT CASE iop
CASE &HD4'/* CSH set clock highspeed */
CASE &H54'/* CSL set clock lowspeed */

CASE &H44: '/* BSR * REL */   'FIXED
           CMDR m.push, reg.pc.H
           CMDR m.push, reg.pc.L
           'I = op6502i(reg.pc)
           'I = I + (I > 127) * 256
           'WORDS reg.pc, word(reg.pc) + I + 1



CASE &H80: '/* BRA * REL */
          i = op6502i(reg.pc)
          i = i + (i > 127) * 256
          WORDS reg.pc, word(reg.pc) + i + 1

CASE &H7C: '/* JMP ($ssss,x) */
        M.LDWORD k: WORDS k, word(k) + reg.x
        reg.pc.L = op6502i(k)
        reg.pc.H = op6502(word(k) + 1)

CASE &HDA: CMDR m.push, reg.x  '  /* PHX */
CASE &H5A: CMDR m.push, reg.y '               /* PHY */
CASE &HFA: CMDR m.pop, reg.x: CMDR m.fl, reg.x '    /* PLX */
CASE &H7A: CMDR m.pop, reg.y: CMDR m.fl, reg.y'      /* PLY */

CASE &H62: reg.a = 0' /* CLA */
CASE &H82: reg.x = 0' /* CLX */
CASE &HC2: reg.y = 0' /* CLY */

CASE &H2:  i = reg.x: reg.x = reg.y: reg.y = i'  /* SXY */
CASE &H22: i = reg.a: reg.a = reg.x: reg.x = i'  /* SAX */
CASE &H42: i = reg.a: reg.a = reg.y: reg.y = i'  /* SAY */

CASE &H3A: CMDR M.DEC, reg.a                  ' /* DEC A */
CASE &H1A: CMDR m.inc, reg.a                  ' /* INC A */



CASE &HD2: CMDR mr.id, i: M.CMP reg.a, i       '/* CMP ($ss) INDIR */
CASE &HB2: CMDR mr.id, reg.a: CMDR m.fl, reg.a '/* LDA ($ss) INDIR */
CASE &H92: cmdc mc.id, j: Wr6502 word(j), reg.a'/* STA ($ss) INDIR */





CASE &H3: io_write 0, nop6502(reg.pc)  '/* ST0 */
CASE &H13: io_write 2, nop6502(reg.pc) '/* ST1 */
CASE &H23: io_write 3, nop6502(reg.pc) '/* ST2 */



CASE &H83: '/* TST #$ss,$ss IMM,ZP */
        i = nop6502(reg.pc): ii = RAMG(MCZp())
        reg.NF = ii
        reg.VF = ii: reg.ZF = i AND ii

CASE &HA3: '/* TST #$ss,$ss,x IMM,ZP,x */
        i = nop6502(reg.pc): ii = RAMG(MCZx())
        reg.NF = ii
        reg.VF = ii: reg.ZF = i AND ii
CASE &H93: '/* TST #$ss,$ssss IMM,ABS */
        i = nop6502(reg.pc): CMDR mr.ab, ii
        reg.NF = ii
        reg.VF = ii: reg.ZF = i AND ii

CASE &HB3: '/* TST #$ss,$ssss,x IMM,ABS,x */
        i = nop6502(reg.pc): CMDR mr.ax, ii
        reg.NF = ii
        reg.VF = ii: reg.ZF = i AND ii

'SBC

CASE &H10: IF (reg.NF AND n.flag) THEN REGINC reg.pc ELSE M.JR  '/* BPL * REL */
CASE &H30: IF (reg.NF AND n.flag) THEN M.JR ELSE REGINC reg.pc  '/* BMI * REL */
CASE &HD0: IF reg.ZF = 0 THEN REGINC reg.pc ELSE M.JR      '/* BNE * REL */
CASE &HF0: IF reg.ZF = 0 THEN M.JR ELSE REGINC reg.pc     '/* BEQ * REL */
CASE &H90: IF (reg.p AND c.flag) THEN REGINC reg.pc ELSE M.JR '/* BCC * REL */
CASE &HB0: IF (reg.p AND c.flag) THEN M.JR ELSE REGINC reg.pc '/* BCS * REL */
CASE &H50: IF (reg.VF AND v.flag) THEN REGINC reg.pc ELSE M.JR'/* BVC * REL */
CASE &H70: IF (reg.VF AND v.flag) THEN M.JR ELSE REGINC reg.pc '/* BVS * REL */


CASE &H40: '/* RTI */

  i = reg.p


  CMDR m.pop.p, reg.p

  IF ((reg.IRequest <> INT.NONE) AND (i AND I.flag) <> 0 AND NOT (reg.p AND I.flag) <> 0) THEN
     REGAfterCLI = 1
    reg.IBackup = reg.ICount
    reg.ICount = 0
    END IF
    CMDR m.pop, reg.pc.L
    CMDR m.pop, reg.pc.H



CASE &H60: '/* RTS */
  CMDR m.pop, reg.pc.L: CMDR m.pop, reg.pc.H: REGINC reg.pc
  'JS = JS - 1
  'REGINC JUMPSTA(JS)
  'PRINT HEX$(word(JUMPSTA(JS)));

CASE &H20: '/* JSR $ssss ABS */

  k.L = nop6502(reg.pc)
  k.H = op6502i(reg.pc)
  'JUMPSTA(JS) = REG.PC
  CMDR m.push, reg.pc.H
  CMDR m.push, reg.pc.L
  reg.pc = k
  'JS = JS + 1
  'JSS = JSS + 1
CASE &H4C: M.LDWORD k: reg.pc = k'/* JMP $ssss ABS */

CASE &H6C: '/* JMP ($ssss) ABDINDIR */
  M.LDWORD k
  reg.pc.L = nop6502(k)
  reg.pc.H = op6502i(k)


CASE &H0: '/* BRK */
  REGINC reg.pc
  CMDR m.push, reg.pc.H: CMDR m.push, reg.pc.L
  CMDR m.push.p, reg.p AND Tn.flag OR (b.flag)
  reg.p = (reg.p OR I.flag) AND DN.FLAG
  k = reg.pc
  reg.pc.L = op6502(VEC.BRK)
  reg.pc.H = op6502(VEC.BRK + 1)
  PRINT ERR, "BRK instruction " + HEX$(word(k) - 1)
  endprog



CASE &H58: '/* CLI */
  IF ((reg.IRequest <> INT.NONE) AND (reg.p AND I.flag) <> 0) THEN

    reg.AfterCLI = 1
    reg.IBackup = reg.ICount
    reg.ICount = 0

  END IF
  reg.p = reg.p AND IN.FLAG



CASE &H28: '/* PLP */
  CMDR m.pop.p, i

  IF ((reg.IRequest <> INT.NONE) AND ((i XOR reg.p) AND notb(i) AND I.flag) <> 0) THEN

    reg.AfterCLI = 1
    reg.IBackup = reg.ICount
    reg.ICount = 0

  END IF
  reg.p = i



CASE &H8: CMDR m.push.p, reg.p AND Tn.flag OR b.flag'     /* PHP */
CASE &H18: reg.p = reg.p AND cn.flag          '     /* CLC */
CASE &HB8: reg.VF = 0                              '     /* CLV */
CASE &HD8: reg.p = reg.p AND DN.FLAG          '     /* CLD */
CASE &H38: reg.p = reg.p OR c.flag                 '     /* SEC */
CASE &HF8: reg.p = reg.p OR D.flag                 '     /* SED */
CASE &H78: reg.p = reg.p OR I.flag                 '     /* SEI */
CASE &H48: CMDR m.push, reg.a          '             /* PHA */
CASE &H68: CMDR m.pop, reg.a: CMDR m.fl, reg.a       '     /* PLA */
CASE &H98: reg.a = reg.y: CMDR m.fl, reg.a     '     /* TYA */

'can i use cmdr m.inc, reg.y ?
CASE &HA8: reg.y = reg.a: CMDR m.fl, reg.y     '     /* TAY */
CASE &HC8: reg.y = reg.y + 1: CMDR m.fl, reg.y '     /* INY */
CASE &H88: reg.y = reg.y - 1: CMDR m.fl, reg.y '     /* DEY */
CASE &H8A: reg.a = reg.x: CMDR m.fl, reg.a     '     /* TXA */
CASE &HAA: reg.x = reg.a: CMDR m.fl, reg.x     '     /* TAX */
CASE &HE8: reg.x = reg.x + 1: CMDR m.fl, reg.x '     /* INX */
CASE &HCA: reg.x = reg.x - 1: CMDR m.fl, reg.x '     /* DEX */
CASE &HEA:  '                                  /* NOP */
CASE &H9A: reg.S = reg.x                 '     /* TXS */
CASE &HBA: reg.x = reg.S: CMDR m.fl, reg.x     '     /* TSX */



CASE &H84: CMDR mw.zp, reg.y                 '  /* STY $ss ZP */
CASE &H85: CMDR mw.zp, reg.a                 '  /* STA $ss ZP */
CASE &H86: CMDR mw.zp, reg.x                 '  /* STX $ss ZP */
CASE &HA4: CMDR mr.zp, reg.y: CMDR m.fl, reg.y    '  /* LDY $ss ZP */
CASE &HA5: CMDR mr.zp, reg.a: CMDR m.fl, reg.a    '  /* LDA $ss ZP */
CASE &HA6: CMDR mr.zp, reg.x: CMDR m.fl, reg.x     '  /* LDX $ss ZP */
CASE &HC4: CMDR mr.zp, i: M.CMP reg.y, i     '  /* CPY $ss ZP */
CASE &HC5: CMDR mr.zp, i: M.CMP reg.a, i     '  /* CMP $ss ZP */
CASE &HE4: CMDR mr.zp, i: M.CMP reg.x, i    '  /* CPX $ss ZP */
CASE &H8C: CMDR mw.ab, reg.y                 '  /* STY $ssss ABS */
CASE &H8D: CMDR mw.ab, reg.a                '  /* STA $ssss ABS */
CASE &H8E: CMDR mw.ab, reg.x                '  /* STX $ssss ABS */
CASE &HAC: CMDR mr.ab, reg.y: CMDR m.fl, reg.y     '  /* LDY $ssss ABS */
CASE &HAD: CMDR mr.ab, reg.a: CMDR m.fl, reg.a    '  /* LDA $ssss ABS */
CASE &HAE: CMDR mr.ab, reg.x: CMDR m.fl, reg.x     '  /* LDX $ssss ABS */
CASE &HCC: CMDR mr.ab, i: M.CMP reg.y, i     '  /* CPY $ssss ABS */
CASE &HCD: CMDR mr.ab, i: M.CMP reg.a, i     '  /* CMP $ssss ABS */
CASE &HEC: CMDR mr.ab, i: M.CMP reg.x, i    '  /* CPX $ssss ABS */
CASE &HA0: CMDR mr.im, reg.y: CMDR m.fl, reg.y     '  /* LDY #$ss IMM */
CASE &HA2: CMDR mr.im, reg.x: CMDR m.fl, reg.x     '  /* LDX #$ss IMM */
CASE &HA9: CMDR mr.im, reg.a: CMDR m.fl, reg.a     '  /* LDA #$ss IMM */
CASE &HC0: CMDR mr.im, i: M.CMP reg.y, i     '  /* CPY #$ss IMM */
CASE &HC9: CMDR mr.im, i: M.CMP reg.a, i     '  /* CMP #$ss IMM */
CASE &HE0: CMDR mr.im, i: M.CMP reg.x, i    '  /* CPX #$ss IMM */
CASE &H94: CMDR mw.zx, reg.y                 '  /* STY $ss,x ZP,x */
CASE &H95: CMDR mw.zx, reg.a                 '  /* STA $ss,x ZP,x */
CASE &H96: CMDR mw.zy, reg.x                 '  /* STX $ss,y ZP,y */
CASE &HB4: CMDR mr.zx, reg.y: CMDR m.fl, reg.y     '  /* LDY $ss,x ZP,x */
CASE &HB5: CMDR mr.zx, reg.a: CMDR m.fl, reg.a     '  /* LDA $ss,x ZP,x */
CASE &HB6: CMDR mr.zy, reg.x: CMDR m.fl, reg.x     '  /* LDX $ss,y ZP,y */
CASE &HD5: CMDR mr.zx, i: M.CMP reg.a, i     '  /* CMP $ss,x ZP,x */



CASE &H99: CMDR mw.ay, reg.a                 '  /* STA $ssss,y ABS,y */
CASE &H9D: CMDR mw.ax, reg.a                 '  /* STA $ssss,x ABS,x */
CASE &HB9: CMDR mr.ay, reg.a: CMDR m.fl, reg.a     '  /* LDA $ssss,y ABS,y */
CASE &HBC: CMDR mr.ax, reg.y: CMDR m.fl, reg.y     '  /* LDY $ssss,x ABS,x */
CASE &HBD: CMDR mr.ax, reg.a: CMDR m.fl, reg.a     '  /* LDA $ssss,x ABS,x */
CASE &HBE: CMDR mr.ay, reg.x: CMDR m.fl, reg.x     '  /* LDX $ssss,y ABS,y */
CASE &HD9: CMDR mr.ay, i: M.CMP reg.a, i     '  /* CMP $ssss,y ABS,y */
CASE &HDD: CMDR mr.ax, i: M.CMP reg.a, i     '  /* CMP $ssss,x ABS,x */
CASE &H81: CMDR mw.ix, reg.a                 '  /* STA ($ss,x) INDEXINDIR */
CASE &H91: CMDR mw.iy, reg.a                 '  /* STA ($ss),y INDIRINDEX */
CASE &HA1: CMDR mr.ix, reg.a: CMDR m.fl, reg.a     '  /* LDA ($ss,x) INDEXINDIR */
CASE &HB1: CMDR mr.iy, reg.a: CMDR m.fl, reg.a     '  /* LDA ($ss),y INDIRINDEX */
CASE &HC1: CMDR mr.ix, i: M.CMP reg.a, i     '  /* CMP ($ss,x) INDEXINDIR */
CASE &HD1: CMDR mr.iy, i: M.CMP reg.a, i     '  /* CMP ($ss),y INDIRINDEX */


CASE &HA:  CMDR m.asl, reg.a                 '  /* ASL a ACC */
CASE &H2A: CMDR M.ROL, reg.a                '  /* ROL a ACC */
CASE &H4A: CMDR M.LSR, reg.a                '  /* LSR a ACC */
CASE &H6A: CMDR M.ROR, reg.a                '  /* ROR a ACC */
CASE ELSE


'  IF (I AND &H87) = &H87 THEN CMDR M.SMB, 2 ^ (I \ 2 ^ 4)
 ' IF (I AND &H7) = &H7 THEN CMDR M.RMB, 2 ^ (I \ 2 ^ 4)
END SELECT

END SUB

SUB BANK.SET (A, b)
END SUB

FUNCTION cmd1 (A)
END FUNCTION

FUNCTION CMD2 (A)
END FUNCTION

SUB cmdc (A, b)

cmdf = cmdf + 1
cmd = A
END SUB

SUB CMDD (A, b)

END SUB

SUB CMDR (cmd1, arg)
IF cmd1 = m.fl AND cmdf = 1 THEN EXIT SUB

cmd = cmd1
cmdf = cmdf + 1
END SUB

FUNCTION cmr1 (A)
END FUNCTION

FUNCTION CMr2 (A)
END FUNCTION

SUB endprog ()
END SUB

SUB io_write (A, b)
END SUB

SUB M.CMP (A, b)
END SUB

SUB M.JR ()
END SUB

SUB M.LDWORD (A)
END SUB

FUNCTION MCZp ()
END FUNCTION

FUNCTION MCZx ()
END FUNCTION

FUNCTION nop6502 (A)
END FUNCTION

FUNCTION notb (A)
END FUNCTION

FUNCTION op6502 (A)
END FUNCTION

FUNCTION op6502i (A)
END FUNCTION

STATIC SUB printt (A, b, C)
N = N + 1
IF N = 1 THEN D$ = "DATA "
IF N <> 1 THEN D$ = D$ + ","
IF b <> 0 THEN
D$ = D$ + LTRIM$(STR$(b))
END IF
IF LEN(D$) > 72 OR A = 255 THEN N = 0: PRINT #1, D$


END SUB

FUNCTION RAMG (A)
END FUNCTION

FUNCTION Rd6502 (q&)
END FUNCTION

SUB REGINC (A)
END SUB

SUB T_INIT (A&, b&, C&)
END SUB

FUNCTION word (A)
END FUNCTION

SUB WORDS (A, b)
END SUB

SUB Wr6502 (A&, b)
END SUB

