SELECT CASE I
CASE &H10: IF (REG.NF AND N.FLAG) THEN REG.PC.W = REG.PC.W + 1:  ELSE M.JR'/* BPL * REL */
CASE &H30: IF (REG.NF AND N.FLAG) THEN M.JR:  ELSE REG.PC.W = REG.PC.W + 1'/* BMI * REL */
CASE &HD0: IF (NOT REG.ZF) THEN REG.PC.W = REG.PC.W + 1 ELSE : M.JR      '/* BNE * REL */
CASE &HF0: IF (NOT REG.ZF) THEN M.JR ELSE : REG.PC.W = REG.PC.W + 1      '/* BEQ * REL */
CASE &H90: IF (REG.P AND C.FLAG) THEN REG.PC.W = REG.PC.W + 1 ELSE : M.JR'/* BCC * REL */
CASE &HB0: IF (REG.P AND C.FLAG) THEN M.JR ELSE : REG.PC.W = REG.PC.W + 1'/* BCS * REL */
CASE &H50: IF (REG.VF AND V.FLAG) THEN REG.PC.W = REG.PC.W + 1 ELSE M.JR'/* BVC * REL */
CASE &H70: IF (REG.VF AND V.FLAG) THEN M.JR ELSE : REG.PC.W = REG.PC.W + 1'/* BVS * REL */


CASE &H40: '/* RTI */

  I = REG.P

  
  M.POP.P REG.P

  IF ((REG.IRequest <> INT.NONE) AND (I AND I.FLAG) <> 0 AND NOT (REG.P AND I.FLAG) <> 0) THEN
     REGAfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0
    END IF
    M.POP REG.PC.B.l
    M.POP REG.PC.B.h
    


CASE &H60: '/* RTS */
  M.POP REG.PC.B.l: M.POP REG.PC.B.h: REG.PC.W = REG.PC.W + 1


CASE &H20: '/* JSR $ssss ABS */
  K.B.l = Op6502(REG.PC.W)
  REG.PC.W = REG.PC.W + 1
  K.B.h = Op6502(REG.PC.W)
  M.PUSH (REG.PC.B.h)
  M.PUSH (REG.PC.B.l)
  REG.PC = K


CASE &H4C: M.LDWORD K: REG.PC = K'/* JMP $ssss ABS */


CASE &H6C: '/* JMP ($ssss) ABDINDIR */
  M.LDWORD K
  REG.PC.B.l = Op6502(K.W)
  K.W = K.W + 1
  REG.PC.B.h = Op6502(K.W)
  


CASE &H0: '/* BRK */
  REG.PC.W = REG.PC + 1
  M.PUSH REG.PC.B.h: M.PUSH REG.PC.B.l
  M.PUSH.P REG.P AND NOT (T.FLAG) OR (B.FLAG)
  REG.P = (REG.P OR I.FLAG) AND NOT (D.FLAG)
  REG.PC.B.l = Op6502(VEC.BRK)
  REG.PC.B.h = Op6502(VEC.BRK + 1)

  PRINT ERR, "BRK instruction"
  END
  


CASE &H58: '/* CLI */
  IF ((REG.IRequest <> INT.NONE) AND (REG.P AND I.FLAG) <> 0) THEN
  END IF
    REG.AfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0

  END IF
  REG.P = REG.P AND NOT (I.FLAG)
  


CASE &H28: '/* PLP */
  M.POP.P I

  IF ((REG.IRequest <> INT.NONE) AND ((I XOR REG.P) AND NOT (I) AND I.FLAG) <> 0) THEN
  
    REG.AfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0

  END IF
  REG.P = I



CASE &H8: M.PUSH.P REG.P AND NOT (T.FLAG) OR B.FLAG'     /* PHP */
CASE &H18: REG.P = REG.P AND NOT (C.FLAG)          '     /* CLC */
CASE &HB8: REG.VF = 0                              '     /* CLV */
CASE &HD8: REG.P = REG.P AND NOT (D.FLAG)          '     /* CLD */
CASE &H38: REG.P = REG.P OR C.FLAG                 '     /* SEC */
CASE &HF8: REG.P = REG.P OR D.FLAG                 '     /* SED */
CASE &H78: REG.P = REG.P OR I.FLAG                 '     /* SEI */
CASE &H48: M.PUSH REG.A          '             /* PHA */
CASE &H68: M.POP REG.A: M.FL REG.A       '     /* PLA */
CASE &H98: REG.A = REG.Y: M.FL REG.A     '     /* TYA */
CASE &HA8: REG.Y = REG.A: M.FL REG.Y     '     /* TAY */
CASE &HC8: REG.Y = REG.Y + 1: M.FL REG.Y '     /* INY */
CASE &H88: REG.Y = REG.Y - 1: M.FL REG.Y '     /* DEY */
CASE &H8A: REG.A = REG.X: M.FL REG.A     '     /* TXA */
CASE &HAA: REG.X = REG.A: M.FL REG.X     '     /* TAX */
CASE &HE8: REG.X = REG.X + 1: M.FL REG.X '     /* INX */
CASE &HCA: REG.X = REG.X - 1: M.FL REG.X '     /* DEX */
CASE &HEA:  '                                  /* NOP */
CASE &H9A: REG.S = REG.X                 '     /* TXS */
CASE &HBA: REG.X = REG.S: M.FL REG.X     '     /* TSX */

CASE &H24: MR.Zp I: M.BIT I            '  /* BIT $ss ZP */
CASE &H2C: MR.Ab I: M.BIT I            '  /* BIT $ssss ABS */

CASE &H5: MR.Zp I: M_ORA I             '  /* ORA $ss ZP */
CASE &H6: MM.Zp M.ASL                  '  /* ASL $ss ZP */
CASE &H25: MR.Zp I: M_AND I            '  /* AND $ss ZP */
CASE &H26: MM.Zp M.ROL                 '  /* ROL $ss ZP */
CASE &H45: MR.Zp I: M.EOR I            '  /* EOR $ss ZP */
CASE &H46: MM.Zp M.LSR                 '  /* LSR $ss ZP */
CASE &H65: MR.Zp I: M_ADC (I)          '  /* ADC $ss ZP */
CASE &H66: MM.Zp M.ROR                 '  /* ROR $ss ZP */
CASE &H84: MW.Zp REG.Y                 '  /* STY $ss ZP */
CASE &H85: MW.Zp REG.A                 '  /* STA $ss ZP */
CASE &H86: MW.Zp REG.X                 '  /* STX $ss ZP */
CASE &HA4: MR.Zp REG.Y: M.FL REG.Y     '  /* LDY $ss ZP */
CASE &HA5: MR.Zp REG.A: M.FL REG.A     '  /* LDA $ss ZP */
'/BaH
'/case &HA5: R.A = RAM[ (Op6502(R.PC.W++)) ]  ;break;
'/CAUTION ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
CASE &HA6: MR.Zp REG.X: M_FL REG.X     '  /* LDX $ss ZP */
CASE &HC4: MR.Zp I: M.CMP REG.Y, I     '  /* CPY $ss ZP */
CASE &HC5: MR.Zp I: M.CMP REG.A, I     '  /* CMP $ss ZP */
CASE &HC6: MM.Zp M.DEC                 '  /* DEC $ss ZP */
CASE &HE4: MR.Zp I: M.CMP REG.X, I     '  /* CPX $ss ZP */
CASE &HE5: MR.Zp I: M.SBC I            '  /* SBC $ss ZP */
CASE &HE6: MM.Zp M.INC                 '  /* INC $ss ZP */

CASE &HD: MR.Ab I: M.ORA I             '  /* ORA $ssss ABS */
CASE &HE: MM.Ab M.ASL                  '  /* ASL $ssss ABS */
CASE &H2D: MR.Ab I: M.AND I            '  /* AND $ssss ABS */
CASE &H2E: MM.Ab M.ROL                 '  /* ROL $ssss ABS */
CASE &H4D: MR.Ab I: M.EOR I            '  /* EOR $ssss ABS */
CASE &H4E: MM.Ab M.LSR                 '  /* LSR $ssss ABS */
CASE &H6D: MR.Ab I: M.ADC I            '  /* ADC $ssss ABS */
CASE &H6E: MM.Ab M.ROR                 '  /* ROR $ssss ABS */
CASE &H8C: MW.Ab REG.Y                 '  /* STY $ssss ABS */
CASE &H8D: MW.Ab REG.A                 '  /* STA $ssss ABS */
CASE &H8E: MW.Ab REG.X                 '  /* STX $ssss ABS */
CASE &HAC: MR.Ab REG.Y: M.FL REG.Y     '  /* LDY $ssss ABS */
CASE &HAD: MR.Ab REG.A: M.FL REG.A     '  /* LDA $ssss ABS */
CASE &HAE: MR.Ab REG.X: M.FL REG.X     '  /* LDX $ssss ABS */
CASE &HCC: MR.Ab I: M.CMP REG.Y, I     '  /* CPY $ssss ABS */
CASE &HCD: MR.Ab I: M.CMP REG.A, I     '  /* CMP $ssss ABS */
CASE &HCE: MM.Ab M.DEC                 '  /* DEC $ssss ABS */
CASE &HEC: MR.Ab I: M.CMP REG.X, I     '  /* CPX $ssss ABS */
CASE &HED: MR.Ab I: M.SBC I            '  /* SBC $ssss ABS */
CASE &HEE: MM.Ab M.INC                 '  /* INC $ssss ABS */

CASE &H9: MR.Im I: M.ORA I             '  /* ORA #$ss IMM */
CASE &H29: MR.Im I: M.AND I            '  /* AND #$ss IMM */
CASE &H49: MR.Im I: M.EOR I            '  /* EOR #$ss IMM */
CASE &H69: MR.Im I: M.ADC I            '  /* ADC #$ss IMM */
CASE &HA0: MR.Im REG.Y: M.FL REG.Y     '  /* LDY #$ss IMM */
CASE &HA2: MR.Im REG.X: M.FL REG.X     '  /* LDX #$ss IMM */
CASE &HA9: MR.Im REG.A: M.FL REG.A     '  /* LDA #$ss IMM */
CASE &HC0: MR.Im I: M.CMP REG.Y, I     '  /* CPY #$ss IMM */
CASE &HC9: MR.Im I: M.CMP REG.A, I     '  /* CMP #$ss IMM */
CASE &HE0: MR.Im I: M.CMP REG.X, I     '  /* CPX #$ss IMM */
CASE &HE9: MR.Im I: M.SBC I            '  /* SBC #$ss IMM */

CASE &H15: MR.Zx I: M.ORA I            '  /* ORA $ss,x ZP,x */
CASE &H16: mm.zx M.ASL                 '  /* ASL $ss,x ZP,x */
CASE &H35: MR.Zx I: M_AND I            '  /* AND $ss,x ZP,x */
CASE &H36: mm.zx M.ROL                 '  /* ROL $ss,x ZP,x */
CASE &H55: MR.Zx I: M_EOR (I)          '  /* EOR $ss,x ZP,x */
CASE &H56: mm.zx M.LSR                 '  /* LSR $ss,x ZP,x */
CASE &H75: MR.Zx I: M.ADC I            '  /* ADC $ss,x ZP,x */
CASE &H76: mm.zx M_ROR                 '  /* ROR $ss,x ZP,x */
CASE &H94: MW.Zx REG.Y                 '  /* STY $ss,x ZP,x */
CASE &H95: MW.Zx REG.A                 '  /* STA $ss,x ZP,x */
CASE &H96: mw.zy REG.X                 '  /* STX $ss,y ZP,y */
CASE &HB4: MR.Zx REG.Y: M.FL REG.Y     '  /* LDY $ss,x ZP,x */
CASE &HB5: MR.Zx REG.A: M.FL REG.A     '  /* LDA $ss,x ZP,x */
CASE &HB6: mr.zy REG.X: M.FL REG.X     '  /* LDX $ss,y ZP,y */
CASE &HD5: MR.Zx I: M.CMP REG.A, I     '  /* CMP $ss,x ZP,x */
CASE &HD6: mm.zx M.DEC                 '  /* DEC $ss,x ZP,x */
CASE &HF5: MR.Zx I: M.SBC (I)          '  /* SBC $ss,x ZP,x */
CASE &HF6: mm.zx M.INC                 '  /* INC $ss,x ZP,x */

CASE &H19: MR.Ay I: M_ORA I            '  /* ORA $ssss,y ABS,y */
CASE &H1D: MR.Ax I: M_ORA I            '  /* ORA $ssss,x ABS,x */
CASE &H1E: mm.ax M.ASL                 '  /* ASL $ssss,x ABS,x */
CASE &H39: MR.Ay I: M.AND I            '  /* AND $ssss,y ABS,y */
CASE &H3D: MR.Ax I: M.AND I            '  /* AND $ssss,x ABS,x */
CASE &H3E: mm.ax M.ROL                 '  /* ROL $ssss,x ABS,x */
CASE &H59: MR.Ay I: M.EOR I            '  /* EOR $ssss,y ABS,y */
CASE &H5D: MR.Ax I: M.EOR I            '  /* EOR $ssss,x ABS,x */
CASE &H5E: mm.ax M.LSR                 '  /* LSR $ssss,x ABS,x */
CASE &H79: MR.Ay I: M.ADC I            '  /* ADC $ssss,y ABS,y */
CASE &H7D: MR.Ax I: M.ADC I            '  /* ADC $ssss,x ABS,x */
CASE &H7E: mm.ax M.ROR                 '  /* ROR $ssss,x ABS,x */
CASE &H99: mw.ay REG.A                 '  /* STA $ssss,y ABS,y */
CASE &H9D: MW.Ax REG.A                 '  /* STA $ssss,x ABS,x */
CASE &HB9: MR.Ay REG.A: M.FL REG.A     '  /* LDA $ssss,y ABS,y */
CASE &HBC: MR.Ax REG.Y: M.FL REG.Y     '  /* LDY $ssss,x ABS,x */
CASE &HBD: MR.Ax REG.A: M.FL REG.A     '  /* LDA $ssss,x ABS,x */
CASE &HBE: MR.Ay REG.X: M.FL REG.X     '  /* LDX $ssss,y ABS,y */
CASE &HD9: MR.Ay I: M.CMP REG.A, I     '  /* CMP $ssss,y ABS,y */
CASE &HDD: MR.Ax I: M.CMP REG.A, I     '  /* CMP $ssss,x ABS,x */
CASE &HDE: mm.ax M.DEC                 '  /* DEC $ssss,x ABS,x */
CASE &HF9: MR.Ay I: M.SBC I            '  /* SBC $ssss,y ABS,y */
CASE &HFD: MR.Ax I: M.SBC I            '  /* SBC $ssss,x ABS,x */
CASE &HFE: mm.ax M.INC                 '  /* INC $ssss,x ABS,x */

CASE &H1: MR.Ix I: M.ORA I             '  /* ORA ($ss,x) INDEXINDIR */
CASE &H11: MR.Iy I: M.ORA I            '  /* ORA ($ss),y INDIRINDEX */
CASE &H21: MR.Ix I: M.AND I            '  /* AND ($ss,x) INDEXINDIR */
CASE &H31: MR.Iy I: M.AND I            '  /* AND ($ss),y INDIRINDEX */
CASE &H41: MR.Ix I: M.EOR I            '  /* EOR ($ss,x) INDEXINDIR */
CASE &H51: MR.Iy I: M.EOR I            '  /* EOR ($ss),y INDIRINDEX */
CASE &H61: MR.Ix I: M.ADC I            '  /* ADC ($ss,x) INDEXINDIR */
CASE &H71: MR.Iy I: M.ADC I            '  /* ADC ($ss),y INDIRINDEX */
CASE &H81: mw.ix REG.A                 '  /* STA ($ss,x) INDEXINDIR */
CASE &H91: mw.iy REG.A                 '  /* STA ($ss),y INDIRINDEX */
CASE &HA1: MR.Ix REG.A: M.FL REG.A     '  /* LDA ($ss,x) INDEXINDIR */
CASE &HB1: MR.Iy REG.A: M.FL REG.A     '  /* LDA ($ss),y INDIRINDEX */
CASE &HC1: MR.Ix I: M.CMP REG.A, I     '  /* CMP ($ss,x) INDEXINDIR */
CASE &HD1: MR.Iy I: M.CMP REG.A, I     '  /* CMP ($ss),y INDIRINDEX */
CASE &HE1: MR.Ix I: M.SBC I            '  /* SBC ($ss,x) INDEXINDIR */
CASE &HF1: MR.Iy I: M.SBC I            '  /* SBC ($ss),y INDIRINDEX */
                                        
CASE &HA: M.ASL REG.A                  '  /* ASL a ACC */
CASE &H2A: M.ROL REG.A                 '  /* ROL a ACC */
CASE &H4A: M.LSR REG.A                 '  /* LSR a ACC */
CASE &H6A: M.ROR REG.A                 '  /* ROR a ACC */
                                        
CASE ELSE
'default:
'  if(_TrapBadOps) {
'    fprintf
'    ( stderr,
'      "[M6502 %lX] Unrecognized instruction: $%02X at PC=$%04X\n",
'      (unsigned)_User,Op6502(REG.PC.W-1),(word)(REG.PC.W-1)
'    );
'
'    _Trace=1;
'
'  }
'
'  break;
END SELECT

