DECLARE FUNCTION XMS.MOVE% (AOFST&, BOFST&, SIZE%)
DECLARE SUB XMS.LOCK (ASEG%, ASAD%)
DECLARE FUNCTION XMS.UNLOCK% ()
DECLARE FUNCTION XMS.MOVES% (ASEG%, ASAD%, BSEG%, BSAD%, SIZE%)
DECLARE FUNCTION xms.free% ()
DECLARE FUNCTION xms.alloc% (SIZE%)
DECLARE FUNCTION XMS.DALLOC% ()
DECLARE SUB XMSFUN1 (FUN%, A%)
DECLARE FUNCTION XMS.RALLOC% (SIZE%)
DECLARE SUB XMSFUN (FUN%, A%, B%)
DECLARE SUB XMSINIT ()
DECLARE SUB DEMO ()
DECLARE FUNCTION xms.dealloc$ (ES%, BX%)
DECLARE FUNCTION INT2STR$ (SWORD%)
DECLARE SUB XMS.ENTRIE (ES%, BX%)
DECLARE FUNCTION XMM.DETECT% ()
DECLARE FUNCTION BIOSXMS.DETECT% ()
DIM SHARED XMSADD%, XMSSEG%, XMSCALL$
DIM SHARED XMSSUB$(7), XHANDLE%, movestr%(7), XMSEC%, INIT%, ALLOC%


'TYPE TBL0 'MOVES (DOS->DOS)
'BYTES AS INTEGER      'SIZE IN BYTES
'NULL AS INTEGER
'ANULL AS INTEGER
'ASAD AS INTEGER       'SOURCE ADDRESS
'ASEG AS INTEGER       '       SEGMENT
'BNULL AS INTEGER
'BSAD AS INTEGER       'DEST   ADDRESS
'BSEG AS INTEGER       '       SEGMENT
'END TYPE

TYPE tbl1 'MOVEX (XMS->DOS)
BYTES AS INTEGER      'SIZE
NULL AS INTEGER
AHANDLE AS INTEGER    'SOURCE HANDLE
AOFST AS LONG         '       OFFSET
BNULL AS INTEGER
BSAD AS INTEGER       'DEST ADDRESS
BSEG AS INTEGER       '     SEGMENT
END TYPE

TYPE tbl2 'MOVEL (DOS->XMS)
BYTES AS INTEGER      'SIZE
NULL AS INTEGER
ANULL AS INTEGER
ASAD AS INTEGER       'SOURCE ADDRESS
ASEG AS INTEGER       '       SEGMENT
BHANDLE AS INTEGER    'DEST HANDLE
BOFST AS LONG         '     OFFSET
END TYPE

'TYPE TBL3 'MOVE  (XMS->XMS)
'BYTES AS INTEGER     'SIZE
'NULL AS INTEGER
'AHANDLE AS INTEGER   'SOURCE HANDLE
'AOFST AS LONG        '       OFFSET
'BHANDLE AS INTEGER   'DEST HANDLE
'BOFST AS LONG        '     OFFSET
'END TYPE


'DIM SHARED MOVE0 AS TBL0, MOVE1 AS TBL1, MOVE2 AS TBL2
DIM SHARED move1 AS tbl1, move2  AS tbl2

CONST XMS.E = 0  'XMS DETECT
CONST XMS.F = 1  'XMS FREE
CONST XMS.A = 2  'XMS ALLOC
CONST XMS.R = 3  'XMS RALLOC
CONST XMS.D = 4  'XMS DALLOC
CONST XMS.L = 5  'XMS LOCK
CONST XMS.U = 6  'XMS UNLOCK
CONST xms.m = 7  'XMS MOVE

FUNCTION INT2STR$ (SWORD%)
'THIS FUNCTION IS TRANSLATING SWORD INTEGERS INTO A STRING. ITS ONLY USE
'IS WHEN YOU STILL USE ASM$ FOR ASSEMBLER FUNCTIONS( LIKE I DO). IN THAT
'CASE YOU CAN MAKE YOUR INTEGER VALUES USABLE ..
'THIS FUNCTION SIMPLY TRANSLATES THE HEXA BYTES
'INTO STRINGBYTES AS IS.
'----------------------------------------------------
DEF SEG = VARSEG(SWORD%)
PTR% = VARPTR(SWORD%)
INT2STR$ = CHR$(PEEK(PTR%)) + CHR$(PEEK(PTR% + 1))
DEF SEG

END FUNCTION

FUNCTION XMM.DETECT% ()
C% = SADD(XMSSUB$(XMS.E))
DEF SEG = SSEG(XMSSUB$(XMS.E))
CALL ABSOLUTE(AX%, C%)
'________________________________________
DEF SEG
XMM.DETECT% = AX%
END FUNCTION

FUNCTION xms.alloc% (SIZE%)
' 0 - 16 16
'17 - 32 32
'33 - 48 48
'49 - 64 64


IF ALLOC% THEN EXIT FUNCTION
IF INIT% THEN ALLOC% = 1

XMSEC% = 0
B% = SIZE%
XMSFUN XMS.A, A%, B% 'B = SIZE | OK=A HANDLE = B
XHANDLE% = B%
IF A% = 0 THEN
xms.alloc% = 0     'ERROR OCCURED
XMSEC% = B%
ELSE
xms.alloc% = B%
END IF
move1.AHANDLE = XHANDLE%
move2.BHANDLE = XHANDLE%
'MOVE3.AHANDLE = XHANDLE%
'MOVE3.BHANDLE = XHANDLE%

END FUNCTION

FUNCTION XMS.DALLOC% ()
ALLOC% = 0
XMSEC% = 0
A% = XHANDLE%
XMSFUN1 XMS.D, A%
XMS.DALLOC% = (A% <= 1) 'SUCCESS
IF A% > 1 THEN XMSEC% = A%
END FUNCTION

SUB XMS.DISPATCH (ES%, BX%)
'----------------------------------------------------------------
'THIS FUNCTION IS A DISPATCHER FOR ALL EXTENDED MEMORY FUNCTIONS
' (8-F)

'YOU SHOULD HAVE EXECUTED THE FUNCTIONS XMS.DETECT AND XMS.ENTRIE FIRST


'STACKPASSING :AX%,BX%,DSDX%

'IN/ OUT      :AX%   AX
'             :BX%   BX
'             :DSDX% DS OR DX DEPENDING ON THE REQUESTED FORMAT

'OUT(GENERAL) :AX% =  0 FAIL , AX%=1 SUCSES
'              DX% =  HANDLE /ERROR
'              BX% LOW BYTE= ERRORCODE

'LOOK FOR SPECIFICS FOR FUNCTIONS IN THE XMS.DOC SUB

'THIS FUNCTION CAN BE INITIALIZED!
'----------------------------------------------------------------
'INIT DRIVER ENTRIE
'-------------------
ES$ = INT2STR$(ES%): BX$ = INT2STR$(BX%)
'------------------------------------------------------------------------
ASM$ = ASM$ + CHR$(&H55)
ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)
ASM$ = ASM$ + CHR$(&H50)
ASM$ = ASM$ + CHR$(&H52)

ASM$ = ASM$ + CHR$(&HB4) + CHR$(&H9)                'MOV AH,9
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H17)               'MOV DX,[BX] 1 KB BLOCKS
ASM$ = ASM$ + CHR$(&H9A) + BX$ + ES$                'CALL DRIVER
ASM$ = ASM$ + CHR$(&H9) + CHR$(&HC0)                'OR AX,AX
ASM$ = ASM$ + CHR$(&H75) + CHR$(&H2)                'JNZ 2
ASM$ = ASM$ + CHR$(&H89) + CHR$(&HDA)               'MOV DX,BX
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
ASM$ = ASM$ + CHR$(&H89) + CHR$(&H17)               'MOV [BX],DX
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)   'MOV BX,[BP+08]
ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX

ASM$ = ASM$ + CHR$(&H5A)                            'POP AX
ASM$ = ASM$ + CHR$(&H58)                            'POP DX
ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)    'RETF 4
'________________________________________
codeoff% = SADD(ASM$)
DEF SEG = SSEG(ASM$)
CALL ABSOLUTE(AX%, dx%, codeoff%)
'________________________________________

END SUB

SUB XMS.ENTRIE (ES%, BX%)
'--------------------------------------------------
'THIS FUNCTION DETECTS DRIVER ENTRIE,
'THE FREE XMS SIZE AND TOTAL XMS SIZE

'STACK PASSING : ES%,BX%

'IN            :

'OUT           : ES%= DRIVER ENTRIE SEGMENT
'                BX%= DRIVER ENTRIE OFFSET

'--------------------------------------------------
ASM$ = ASM$ + CHR$(&H55)                             'PUSH BP
ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)                'MOV BP,SP
ASM$ = ASM$ + CHR$(&H50)                             'PUSH AX
ASM$ = ASM$ + CHR$(&H53)                             'PUSH BX
ASM$ = ASM$ + CHR$(&H6)                              'PUSH ES

ASM$ = ASM$ + CHR$(&HB8) + CHR$(&H10) + CHR$(&H43)   'MOV AX,4310
ASM$ = ASM$ + CHR$(&HCD) + CHR$(&H2F)                'INT 2F GET DRIVER ENTRIE
ASM$ = ASM$ + CHR$(&H89) + CHR$(&HD8)                'MOV AX,BX (NEED TO STORE BX)
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)    'MOV BX,[BP+08]
ASM$ = ASM$ + CHR$(&H8C) + CHR$(&H7)                 'MOV [BX],ES SEG DRIVER
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)    'MOV BX,[BP+06]
ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                 'MOV [BX],AX OFF DRIVER

ASM$ = ASM$ + CHR$(&H7)                              'POP ES
ASM$ = ASM$ + CHR$(&H5B)                             'POP BX
ASM$ = ASM$ + CHR$(&H58)                             'POP AX
ASM$ = ASM$ + CHR$(&H5D)                             'POP BP
ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)     'RETF 4
'________________________________________
codeoff% = SADD(ASM$)
DEF SEG = SSEG(ASM$)
CALL ABSOLUTE(ES%, BX%, codeoff%)

'________________________________________
DEF SEG

END SUB

FUNCTION xms.free% ()
XMSFUN XMS.F, A%, B%
xms.free = A% 'total or left?
END FUNCTION

STATIC SUB XMS.MOVEL (ASEG%, ASAD%, OFST&, SIZE%)
'XMSEC% = 0
move2.BYTES = SIZE%
move2.ASAD% = ASAD%
move2.ASEG% = ASEG%
move2.BOFST = OFST&
A% = VARSEG(move2)
B% = VARPTR(move2)
XMSFUN xms.m, A%, B%
'XMS.MOVEL% = (A% = 0)
'IF A% THEN XMSEC% = A%
END SUB

STATIC SUB XMS.MOVEX (ASEG%, ASAD%, OFST&, SIZE%)
'xmsec%=0
move1.BYTES = SIZE%
move1.BSAD% = ASAD%
move1.BSEG% = ASEG%
move1.AOFST = OFST&
A% = VARSEG(move1)
B% = VARPTR(move1)
XMSFUN xms.m, A%, B%
'XMS.MOVEX% = (A% = 0)
'IF A% THEN XMSEC% = A%



END SUB

STATIC SUB XMSFUN (FUN%, A%, B%)
OFT% = SADD(XMSSUB$(FUN%)): DEF SEG = SSEG(XMSSUB$(FUN%))
CALL ABSOLUTE(A%, B%, OFT%)
END SUB

STATIC SUB XMSFUN1 (FUN%, A%)
OFT% = SADD(XMSSUB$(FUN%)): DEF SEG = SSEG(XMSSUB$(FUN%))
CALL ABSOLUTE(A%, OFT%)
END SUB

SUB XMSINIT ()
INIT% = 1
XMS.ENTRIE ES%, BX%

XMSSEG% = ES%
XMSADD% = BX%
XMSCALL$ = MKI$(BX%) + MKI$(ES%)




   ASM$ = ""
   ASM$ = ASM$ + CHR$(&H55)                           'PUSH BP
   ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)              'MOV BP,SP
   ASM$ = ASM$ + CHR$(&H50)                           'PUSH AX
   ASM$ = ASM$ + CHR$(&HB8) + CHR$(&H0) + CHR$(&H43)  'MOV AX,4300
   ASM$ = ASM$ + CHR$(&HCD) + CHR$(&H2F)              'INT 2F
   ASM$ = ASM$ + CHR$(&H3C) + CHR$(&H80)              'CMP AL,80
   ASM$ = ASM$ + CHR$(&H74) + CHR$(&H2)               'JZ 2
   ASM$ = ASM$ + CHR$(&H31) + CHR$(&HC0)              'XOR AX,AX
   ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)  'MOV BX,[BP+06]
   ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)               'MOV [BX],AX
   ASM$ = ASM$ + CHR$(&H58)                           'POP AX
   ASM$ = ASM$ + CHR$(&H5D)                           'POP BP
   ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H2) + CHR$(&H0)   'RETF 2
XMSSUB$(XMS.E) = ASM$ 'DETECT

  ASM$ = ""
  ASM$ = ASM$ + CHR$(&H55)                            'PUSH BP
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)               'MOV BP,SP
  ASM$ = ASM$ + CHR$(&H50)                            'PUSH AX
  ASM$ = ASM$ + CHR$(&H53)                            'PUSH BX
  ASM$ = ASM$ + CHR$(&H52)                            'PUSH DX

  ASM$ = ASM$ + CHR$(&HB4) + CHR$(&H8)                'MOV AH,0800 QUERY FREE XMS
  ASM$ = ASM$ + CHR$(&H9A) + XMSCALL$                'CALL DRIVER
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H17)               'MOV [BX],DX
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)   'MOV BX,[BP+08]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX

  ASM$ = ASM$ + CHR$(&H5A)                            'POP DX
  ASM$ = ASM$ + CHR$(&H5B)                            'POP BX
  ASM$ = ASM$ + CHR$(&H58)                            'POP AX
  ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
  ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)    'RETF 4
XMSSUB$(XMS.F) = ASM$ 'XMS.FREE

  ASM$ = ""
  ASM$ = ASM$ + CHR$(&H55)
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)
  ASM$ = ASM$ + CHR$(&H50)
  ASM$ = ASM$ + CHR$(&H52)

  ASM$ = ASM$ + CHR$(&HB4) + CHR$(&H9)                'MOV AH,9
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H17)               'MOV DX,[BX] 1 KB BLOCKS
  ASM$ = ASM$ + CHR$(&H9A) + XMSCALL$                'CALL DRIVER
  ASM$ = ASM$ + CHR$(&H9) + CHR$(&HC0)                'OR AX,AX
  ASM$ = ASM$ + CHR$(&H75) + CHR$(&H2)                'JNZ 2
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HDA)               'MOV DX,BX
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H17)               'MOV [BX],DX
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)   'MOV BX,[BP+08]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX

  ASM$ = ASM$ + CHR$(&H5A)                            'POP AX
  ASM$ = ASM$ + CHR$(&H58)                            'POP DX
  ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
  ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)    'RETF 4
  
XMSSUB$(XMS.A) = ASM$ 'XMS.ALLOC



  ASM$ = ""
  ASM$ = ASM$ + CHR$(&H55)                            'push bp
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)               'mov bp,sp
  ASM$ = ASM$ + CHR$(&H50)                            'push ax
  ASM$ = ASM$ + CHR$(&H52)                            'push dx

  ASM$ = ASM$ + CHR$(&HB4) + CHR$(&HF)                'MOV AH,F
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H17)               'MOV DX,[BX] XMS handle
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5F) + CHR$(&H8)   'MOV BX,[BP+08]
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H1F)               'MOV BX,[BX]
  ASM$ = ASM$ + CHR$(&H9A) + XMSCALL$                'CALL DRIVER
  ASM$ = ASM$ + CHR$(&H9) + CHR$(&HC0)                'OR AX,AX
  ASM$ = ASM$ + CHR$(&H75) + CHR$(&H2)                'JNZ 2
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HD9)               'MOV AX,BX
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX


  ASM$ = ASM$ + CHR$(&H5A)                            'POP dX
  ASM$ = ASM$ + CHR$(&H58)                            'POP aX
  ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
  ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)    'RETF 4
XMSSUB$(XMS.R) = ASM$ 'REALLOC

  ASM$ = ""
  ASM$ = ASM$ + CHR$(&H55)                            'PUSH BP
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)               'MOV BP,SP
  ASM$ = ASM$ + CHR$(&H50)                            'PUSH AX
  ASM$ = ASM$ + CHR$(&H52)                            'PUSH DX

  ASM$ = ASM$ + CHR$(&HB4) + CHR$(&HA)                'MOV AH,A
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H17)               'MOV DX,[BX] HANDLE
  ASM$ = ASM$ + CHR$(&H9A) + XMSCALL$                'CALL DRIVER
  ASM$ = ASM$ + CHR$(&H9) + CHR$(&HC0)                'OR AX,AX
  ASM$ = ASM$ + CHR$(&H75) + CHR$(&H2)                'JNZ 2
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HD9)               'MOV AX,BX
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX

  ASM$ = ASM$ + CHR$(&H5A)                            'POP dX
  ASM$ = ASM$ + CHR$(&H58)                            'POP aX
  ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
  ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H2) + CHR$(&H0)    'RETF 2
XMSSUB$(XMS.D) = ASM$ ' DEALLOC

  ASM$ = ""
  ASM$ = ASM$ + CHR$(&H55)                            'push bp
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)               'mov bp,sp
  ASM$ = ASM$ + CHR$(&H50)                            'push ax
  ASM$ = ASM$ + CHR$(&H52)                            'push dx

  ASM$ = ASM$ + CHR$(&HB4) + CHR$(&HC)                'MOV AH,C
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H17)               'MOV DX,[BX] handle
  ASM$ = ASM$ + CHR$(&H9A) + XMSCALL$                'CALL DRIVER
  ASM$ = ASM$ + CHR$(&H9) + CHR$(&HC0)                'OR AX,AX
  ASM$ = ASM$ + CHR$(&H75) + CHR$(&H4)                'JNZ 4
  ASM$ = ASM$ + CHR$(&H30) + CHR$(&HFF)               'XOR BH,BH  'to zero on error
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HDA)               'MOV DX,BX  'and put in DX
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HD8)               'mov ax,bx  'need bx
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H17)               'MOV [BX],DX
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)   'MOV BX,[BP+08]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX

  ASM$ = ASM$ + CHR$(&H5A)                            'POP AX
  ASM$ = ASM$ + CHR$(&H58)                            'POP DX
  ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
  ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)    'RETF 4
XMSSUB$(XMS.L) = ASM$ 'lock

  ASM$ = ""
  ASM$ = ASM$ + CHR$(&H55)                            'push bp
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)               'mov bp,sp
  ASM$ = ASM$ + CHR$(&H50)                            'push ax
  ASM$ = ASM$ + CHR$(&H52)                            'push dx

  ASM$ = ASM$ + CHR$(&HB4) + CHR$(&HD)                'MOV AH,D
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H17)               'MOV DX,[BX] handle
  ASM$ = ASM$ + CHR$(&H9A) + XMSCALL$                'CALL DRIVER
  ASM$ = ASM$ + CHR$(&H9) + CHR$(&HC0)                'OR AX,AX
  ASM$ = ASM$ + CHR$(&H75) + CHR$(&H2)                'JNZ 2
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HD9)               'MOV AX,BX
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX

  ASM$ = ASM$ + CHR$(&H5A)                            'POP AX
  ASM$ = ASM$ + CHR$(&H58)                            'POP DX
  ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
  ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H2) + CHR$(&H0)    'RETF 2
XMSSUB$(XMS.U) = ASM$ 'unlock

  ASM$ = ""
  ASM$ = ASM$ + CHR$(&H55)                            'Push AX
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)               'MOV BP,SP
  ASM$ = ASM$ + CHR$(&H56)                            'Push SI
  ASM$ = ASM$ + CHR$(&H1E)                            'Push DS


  ASM$ = ASM$ + CHR$(&HB4) + CHR$(&HB)                'MOV AH,B
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H37)               'MOV SI,[BX] OFFSET
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)   'MOV BX,[BP+08]
  ASM$ = ASM$ + CHR$(&H8E) + CHR$(&H1F)               'MOV DS,[BX] SEGMENT
  ASM$ = ASM$ + CHR$(&H9A) + XMSCALL$                'CALL DRIVER
  ASM$ = ASM$ + CHR$(&H9) + CHR$(&HC0)                'OR AX,AX 'SUCSES ?
  ASM$ = ASM$ + CHR$(&H74) + CHR$(&H2)                'JZ 2    'NO ? JUMP
  ASM$ = ASM$ + CHR$(&H31) + CHR$(&HDB)               'XOR BX,BX
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HD8)               'MOV AX,BX
  ASM$ = ASM$ + CHR$(&H1F)                            'POP DS  'have to restore before [bx] is adressed
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)   'MOV BX,[BP+08]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX

  ASM$ = ASM$ + CHR$(&H5E)                            'POP SI
  ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
  ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)    'RETF 4
XMSSUB$(xms.m) = ASM$ 'move

END SUB

