.model medium,basic
.486
;DECLARE SUB xmsinit (size%)
;DECLARE SUB xmsend
;DECLARE SUB xmserror (errr%)
;DECLARE SUB dos2xmsm ALIAS "dos2xmsa" (size&, BYVAL src_seg%, BYVAL src_ofs, des&)
;DECLARE SUB dos2xmsi ALIAS "dos2xmsa" (sizeof2&, SEG srcbuf%, des&)
;DECLARE SUB dos2xmsa (sizeofbuf&, SEG srcbuf as any, des&)
;DECLARE SUB dos2xms (size&, src&, des&)
;DECLARE SUB xms2dosm ALIAS "dos2xmsa" (size&, src&, BYVAL des_seg%, BYVAL des_ofs)
;DECLARE SUB xms2dosi ALIAS "xms2dosa" (sizeof2&, src&, SEG desbuf%)
;DECLARE SUB xms2dosa (sizeofbuf&, src&, SEG desbuf as any)
;DECLARE SUB xms2dos (size&, src&, des&)
;DECLARE SUB xms2xms (size&, src&, des&)
;DECLARE SUB dos2dos (size&, src&, des&)
ext_mem_move    struct
        sizeb           dd      0
        src_hndl        dw      0
        src_ofst        dd      0
        des_hndl        dw      0
        des_ofst        dd      0
ext_mem_move    ends

.data
handle          dw              0
move_blockdx    ext_mem_move    <>
move_blockxd    ext_mem_move    <>
move_blockdd    ext_mem_move    <>
move_blockxx    ext_mem_move    <>
xms_call        dd              0
xms_error       dw              0
xms_status      dw              0
xms_init        dw              0
xms_ver         dw              0
xms_rev         dw              0
xms_lock        dd              0
xms_size        dw              0

.code


;*************************( XMSINIT )*********************************
        public xmsinit
xmsinit proc far
        push bp
        mov bp,sp
        push es
        mov bx,[bp+6] ;size
        mov bx,[bx]
        mov xms_size,bx
        mov ax,4300h
        int 2fh
        cmp al,80h
        je xmsdriverinst
        mov xms_init,0
        jmp short xmsinitend
xmsdriverinst:
        mov xms_init,1
        mov ax,4310h
        int 2fh
        mov word ptr xms_call,bx
        mov word ptr xms_call+2,es
xmsgetver:
        mov ah,0
        call xms_call;
        mov xms_ver,AX  ;xms version
        mov xms_rev,BX  ;xms revision

        call allocemb        
xmsinitend:
        mov ax,handle
        mov move_blockdx.des_hndl,ax
        mov move_blockxd.src_hndl,ax
        mov move_blockxx.src_hndl,ax
        mov move_blockxx.des_hndl,ax
        mov move_blockdx.src_hndl,0
        mov move_blockxd.des_hndl,0
        mov move_blockdd.src_hndl,0
        mov move_blockdd.des_hndl,0

        pop es
        pop bp
        ret 2
xmsinit endp


;******************************( allocemb )*************************
allocemb:
        mov ah,9
        mov dx,xms_size
        call xms_call
        mov handle,dx
        ;ax=1 ok ax=0 bl err
        mov xms_status, ax
        mov xms_error,bx
        ret


;******************************( dos2xms )*************************
        public dos2xms          ;[bp+6] des [bp+8] src [bp+10] size
dos2xms proc
        push bp
        mov bp,sp
        push es
        mov bx,[bp+6] ;seg

        mov eax,[bx]
        mov move_blockdx.des_ofst, eax

        mov bx,[bp+8] ;seg
        mov eax,[bx]
        mov move_blockdx.src_ofst, eax

        mov bx,[bp+10] ;seg
        mov eax,[bx]
        mov move_blockdx.sizeb, eax

        mov  si,offset move_blockdx
        call moveemb
        pop es
        pop bp
        ret 6
dos2xms endp

;******************************( xms2dos )*************************

        public xms2dos
xms2dos proc
        push bp
        mov bp,sp
        push es
        mov bx,[bp+6] ;seg
        mov eax,[bx]
        mov move_blockxd.des_ofst, eax
        
        mov bx,[bp+8] ;seg
        mov eax,[bx]
        mov move_blockxd.src_ofst, eax
        
        mov bx,[bp+10] ;seg
        mov eax,[bx]
        mov move_blockxd.sizeb, eax
        
        mov  si,offset move_blockxd
        call moveemb
        pop es
        pop bp
        ret 6
xms2dos endp


;******************************( dos2dos )*************************

        public dos2dos
dos2dos proc
        push bp
        mov bp,sp
        push es
        mov bx,[bp+6] ;seg
        mov eax,[bx]
        mov move_blockdd.des_ofst, eax
        
        mov bx,[bp+8] ;seg
        mov eax,[bx]
        mov move_blockdd.src_ofst, eax
        
        mov bx,[bp+10] ;seg
        mov eax,[bx]
        mov move_blockdd.sizeb, eax

        mov  si,offset move_blockdd
        call moveemb
        pop es
        pop bp
        ret 6
dos2dos endp

;******************************( xms2xms )*************************
        public xms2xms
xms2xms proc
        push bp
        mov bp,sp
        push es
        mov bx,[bp+6] ;seg
        mov eax,[bx]
        mov move_blockxx.des_ofst, eax
        mov bx,[bp+8] ;seg
        mov eax,[bx]
        mov move_blockxx.src_ofst, eax
        mov bx,[bp+10] ;seg
        mov eax,[bx]
        mov move_blockxx.sizeb, eax

        mov  si,offset move_blockxx
        call moveemb
        pop es
        pop bp
        ret 6
xms2xms endp

;******************************( dos2xmsa )*************************
        public dos2xmsa          ;[bp+6] des [bp+8] srcoff [bp+10] srcseg [bp+12] size
dos2xmsa proc
        push bp
        mov bp,sp

        mov bx,[bp+6] ;ptr des_ofst
        mov eax,[bx]
        mov move_blockdx.des_ofst, eax

        mov ax,[bp+8]  ;src_off
        mov bx,[bp+10] ;src_seg
        mov word ptr move_blockdx.src_ofst, ax
        mov word ptr move_blockdx.src_ofst+2,bx

        mov bx,[bp+12] ;ptr size
        mov eax,[bx]
        mov move_blockdx.sizeb, eax

        mov  si,offset move_blockdx
        call moveemb
        pop bp
        ret 8
dos2xmsa endp

;******************************( xms2dosa )*************************
        public xms2dosa          ;[bp+6] desoff [bp+8] desseg [bp+10] src [bp+12] size
xms2dosa proc
        push bp
        mov bp,sp
        push es

        mov ax,[bp+6] ;des_off
        mov bx,[bp+8] ;des_seg
        mov word ptr move_blockxd.des_ofst, ax
        mov word ptr move_blockxd.des_ofst+2,bx

        mov bx,[bp+10]  ;ptr src_ofst
        mov eax,[bx]
        mov move_blockxd.src_ofst, eax

        mov bx,[bp+12] ;ptr size
        mov eax,[bx]
        mov move_blockxd.sizeb, eax

        mov  si,offset move_blockxd
        call moveemb
        pop es
        pop bp
        ret 8
xms2dosa endp





;******************************( moveemb )*************************
moveemb:
        mov ah,0bh
        call xms_call
        ;ax=1 ok ax=0 bl err
        mov xms_status, ax
        mov xms_error,bx
        ret

;******************************( xmsend )*************************

        public xmsend
xmsend  proc
        mov ax,xms_init
        cmp ax,0
        je xmsendend
        call freeemb
        ret
xmsend  endp

;******************************( freeemb )*************************
freeemb:
        mov ah,0ah
        mov dx,handle
        call xms_call
        ;ax=1 ok ax=0 bl err
        mov xms_status, ax
        mov xms_error,bx
xmsendend:
        ret

;******************************( lockemb )*************************
lockemb:
        mov ah,0ch
        mov dx,handle
        call xms_call
        mov word ptr xms_lock,bx
        mov word ptr xms_lock+2,dx
        ;ax=1 ok ax=0 bl err
        mov xms_status, ax
        mov xms_error,bx
        ret

;******************************( unlockemb )*************************
unlockemb:
        mov ah,0dh
        mov dx,handle
        call xms_call
        ;ax=1 ok ax=0 bl err
        mov xms_status, ax
        mov xms_error,bx
        ret

;******************************( xmserror )*************************
        public xmserror
xmserror proc
        push bp
        mov bp,sp
        mov bx,[bp+6] ;errr
        mov ax,xms_init      ;see if xms is installed
        cmp ax,1
        je xmserror1         
        mov ax,0ffffh        ;set status=-1, if not
        jmp short xmserror2
xmserror1:
        mov ax,xms_status
        cmp ax,0
        je xmserror2
        mov ax,xms_error
        and ax, 0ffh
        mov xms_status,0
xmserror2:                ;ax=0,no error
        mov [bx], ax      ;store errr
        pop bp
        ret 2
xmserror endp
end








