DECLARE SUB XMSFUN (FUN%, A%, B%)
DECLARE SUB XMSINIT ()
DECLARE FUNCTION xms.unlock$ (ES%, BX%)
DECLARE FUNCTION XMS.FREE$ (ES%, BX%)
DECLARE FUNCTION xms.realloc$ (ES%, BX%)
DECLARE FUNCTION XMS.MOVE$ (ES%, BX%)
DECLARE SUB DEMO ()
DECLARE FUNCTION xms.dealloc$ (ES%, BX%)
DECLARE FUNCTION XMS.ALLOC$ (ES%, BX%)
DECLARE FUNCTION INT2STR$ (SWORD%)
DECLARE SUB XMS.ENTRIE (ES%, BX%)
DECLARE FUNCTION XMM.DETECT% ()
DECLARE FUNCTION BIOSXMS.DETECT% ()
DECLARE FUNCTION xms.lock$ (ES%, BX%)
DECLARE FUNCTION xsm.unlock$ (ES%, BX%)
DIM SHARED XMSADD%, XMSSEG%, XMSCALL$
DIM SHARED XMSSUB$(7)
CONST XMS.E = 0
CONST XMS.F = 1
CONST XMS.A = 2
CONST XMS.R = 3
CONST XMS.D = 4
CONST XMS.L = 5
CONST XMS.U = 6
CONST XMS.M = 7

XMSINIT

XMSFUN XMS.F, A%, B%
PRINT A%, B%
'XMS.FREE


FUNCTION BIOSXMS.DETECT% ()
'------------------------------------------------------
'THIS FUNCTION RETURNS XMS MEMORY BLOCKS OF 1KB
'FOR 286 AND 386 WITHOUT XMS MANAGER INSTALLED

'STACKPASSING :AX%

'IN:

'OUT          :AX%--NR OF 1 KB EXTENDED MEMBLOCKS

'ERRORRETURN  :AX%= 0 THEN FUNCTION NOT SUPPORTED OR XMS
'                     HANDLER INSTALLED
'-------------------------------------------------------
ASM$ = ASM$ + CHR$(&H55)                            'PUSH BP
ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)               'MOV BP,SP
ASM$ = ASM$ + CHR$(&H50)                            'PUSH AX

ASM$ = ASM$ + CHR$(&HB4) + CHR$(&H88)               'MOV AH,88
ASM$ = ASM$ + CHR$(&HCD) + CHR$(&H15)               'INT 15
ASM$ = ASM$ + CHR$(&H72) + CHR$(&H5)                'JC 5
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX

ASM$ = ASM$ + CHR$(&H58)                            'POP AX
ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H2) + CHR$(&H0)    'RETF 2
'________________________________________
codeoff% = SADD(ASM$)
DEF SEG = SSEG(ASM$)
CALL ABSOLUTE(AX%, codeoff%)
'________________________________________
DEF SEG
BIOSXMS.DETECT% = AX%
END FUNCTION

SUB DATASEGMENT (LENGTH%)
'THIS SUB IS OFFERING THE MINIMAL NECESSARY REQUIREMENTS FOR SETTING
'UP A DATASEGMENT IN YOUR ASSEMBLER SUBS.
'-------------------------------------------------------------------------
'DATA
DIM DATAS%(LENGTH%)
DATASEG% = VARSEG(DATAS%(0)): DATAOFF% = VARPTR(DATAS%(0))
DATASEG$ = INT2STR$(DATASEG%): DATAOFF$ = INT2STR$(DATAOFF%)
'-----------------------------------
'CODE
ASM$ = ASM$ + CHR$(&H50)                 'PUSH AX
ASM$ = ASM$ + CHR$(&H1E)                 'PUSH DS
ASM$ = ASM$ + CHR$(&HB8) + DATASEG$      'MOV AX,DATASEG$
ASM$ = ASM$ + CHR$(&H8E) + CHR$(&HD8)    'MOV DS,AX
ASM$ = ASM$ + CHR$(&H1F)                 'POP DS
ASM$ = ASM$ + CHR$(&H58)                 'POP AX
'------------------------------------------------------------------------
END SUB

SUB helpjes ()
'-----------------------------------
'mov bx,[bp+06]
'mov dx,[bx]
'mov bx,[bx+08]
'mov bx,[bx]
'-----------------------------------

ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H17)
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5F) + CHR$(&H8)
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H1F)
'________________________________________
codeoff% = SADD(ASM$)
DEF SEG = SSEG(ASM$)
CALL ABSOLUTE(codeoff%)
'________________________________________
DEF SEG


END SUB

FUNCTION INT2STR$ (SWORD%)
'THIS FUNCTION IS TRANSLATING SWORD INTEGERS INTO A STRING. ITS ONLY USE
'IS WHEN YOU STILL USE ASM$ FOR ASSEMBLER FUNCTIONS( LIKE I DO). IN THAT
'CASE YOU CAN MAKE YOUR INTEGER VALUES USABLE ..
'THIS FUNCTION SIMPLY TRANSLATES THE HEXA BYTES
'INTO STRINGBYTES AS IS.
'----------------------------------------------------
DEF SEG = VARSEG(SWORD%)
PTR% = VARPTR(SWORD%)
INT2STR$ = CHR$(PEEK(PTR%)) + CHR$(PEEK(PTR% + 1))
DEF SEG

END FUNCTION

SUB POKESTRING (SEGJE%, OFFJE%, MAIN$)
'------------------------------------------------------
'THIS FUNCTION POKES A STRING (MIGHT BE ASCIIZ)INTO
'MEMORY AT A GIVEN LOCATION, MAKING IT POSSIBLE TO
'ACCESS STRINGS IN BYTE FORM
'------------------------------------------------------

DEF SEG = SEGJE%
FOR i% = 0 TO LEN(MAIN$) - 1
  POKE OFFJE% + i%, ASC(MID$(MAIN$, i% + 1, 1))
NEXT
DEF SEG

END SUB

SUB PROCSEGMENT (LENGTH%)
'------------------------------------------------------------------------
'THIS SUB IS GIVING THE MINIMAL REQUIREMENTS FOR AN PROCEDURE SEGMENT.
'IN GENERAL THIS PROC SEGMENT SHOULD BE PART OF YOUR MAIN PROGRAM.
'------------------------------------------------------------------------
'PROC
'-----
DIM PROCS%(LENGTH%)
PROCSEG% = VARSEG(PROCS%(0)): PROCOFF% = VARPTR(PROCS%(0))
PRNOFF% = PROCOFF% + LEN(NEWINT$): PROCOFF$ = INT2STR$(PROCOFF%)

'CODE
'-----
ASM$ = ASM$ + CHR$(&H9A) + NEWINTOFF$ + PROCSEG$  'CALL PROCSEG[NEWINTOFF$]

END SUB

FUNCTION XMM.DETECT% ()
C% = SADD(XMSSUB$(0))
DEF SEG = SSEG(XMSSUB$(0))
CALL ABSOLUTE(AX%, C%)
'________________________________________
DEF SEG
XMM.DETECT% = AX%
END FUNCTION

SUB XMS.DISPATCH (ES%, BX%)
'----------------------------------------------------------------
'THIS FUNCTION IS A DISPATCHER FOR ALL EXTENDED MEMORY FUNCTIONS
' (8-F)

'YOU SHOULD HAVE EXECUTED THE FUNCTIONS XMS.DETECT AND XMS.ENTRIE FIRST


'STACKPASSING :AX%,BX%,DSDX%

'IN/ OUT      :AX%   AX
'             :BX%   BX
'             :DSDX% DS OR DX DEPENDING ON THE REQUESTED FORMAT

'OUT(GENERAL) :AX% =  0 FAIL , AX%=1 SUCSES
'              DX% =  HANDLE /ERROR
'              BX% LOW BYTE= ERRORCODE

'LOOK FOR SPECIFICS FOR FUNCTIONS IN THE XMS.DOC SUB

'THIS FUNCTION CAN BE INITIALIZED!
'----------------------------------------------------------------
'INIT DRIVER ENTRIE
'-------------------
ES$ = INT2STR$(ES%): BX$ = INT2STR$(BX%)
'------------------------------------------------------------------------
ASM$ = ASM$ + CHR$(&H55)
ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)
ASM$ = ASM$ + CHR$(&H50)
ASM$ = ASM$ + CHR$(&H52)

ASM$ = ASM$ + CHR$(&HB4) + CHR$(&H9)                'MOV AH,9
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H17)               'MOV DX,[BX] 1 KB BLOCKS
ASM$ = ASM$ + CHR$(&H9A) + BX$ + ES$                'CALL DRIVER
ASM$ = ASM$ + CHR$(&H9) + CHR$(&HC0)                'OR AX,AX
ASM$ = ASM$ + CHR$(&H75) + CHR$(&H2)                'JNZ 2
ASM$ = ASM$ + CHR$(&H89) + CHR$(&HDA)               'MOV DX,BX
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
ASM$ = ASM$ + CHR$(&H89) + CHR$(&H17)               'MOV [BX],DX
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)   'MOV BX,[BP+08]
ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX

ASM$ = ASM$ + CHR$(&H5A)                            'POP AX
ASM$ = ASM$ + CHR$(&H58)                            'POP DX
ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)    'RETF 4
'________________________________________
codeoff% = SADD(ASM$)
DEF SEG = SSEG(ASM$)
CALL ABSOLUTE(AX%, dx%, codeoff%)
'________________________________________

END SUB

SUB XMS.ENTRIE (ES%, BX%)
'--------------------------------------------------
'THIS FUNCTION DETECTS DRIVER ENTRIE,
'THE FREE XMS SIZE AND TOTAL XMS SIZE

'STACK PASSING : ES%,BX%

'IN            :

'OUT           : ES%= DRIVER ENTRIE SEGMENT
'                BX%= DRIVER ENTRIE OFFSET

'--------------------------------------------------
ASM$ = ASM$ + CHR$(&H55)                             'PUSH BP
ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)                'MOV BP,SP
ASM$ = ASM$ + CHR$(&H50)                             'PUSH AX
ASM$ = ASM$ + CHR$(&H53)                             'PUSH BX
ASM$ = ASM$ + CHR$(&H6)                              'PUSH ES

ASM$ = ASM$ + CHR$(&HB8) + CHR$(&H10) + CHR$(&H43)   'MOV AX,4310
ASM$ = ASM$ + CHR$(&HCD) + CHR$(&H2F)                'INT 2F GET DRIVER ENTRIE
ASM$ = ASM$ + CHR$(&H89) + CHR$(&HD8)                'MOV AX,BX (NEED TO STORE BX)
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)    'MOV BX,[BP+08]
ASM$ = ASM$ + CHR$(&H8C) + CHR$(&H7)                 'MOV [BX],ES SEG DRIVER
ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)    'MOV BX,[BP+06]
ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                 'MOV [BX],AX OFF DRIVER

ASM$ = ASM$ + CHR$(&H7)                              'POP ES
ASM$ = ASM$ + CHR$(&H5B)                             'POP BX
ASM$ = ASM$ + CHR$(&H58)                             'POP AX
ASM$ = ASM$ + CHR$(&H5D)                             'POP BP
ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)     'RETF 4
'________________________________________
codeoff% = SADD(ASM$)
DEF SEG = SSEG(ASM$)
CALL ABSOLUTE(ES%, BX%, codeoff%)

'________________________________________
DEF SEG

END SUB

SUB XMSFUN (FUN%, A%, B%)

FUN$ = XMSSUB$(FUN%)
OFT% = SADD(FUN$): DEF SEG = SSEG(FUN$)
CALL ABSOLUTE(A%, B%, OFT%)
END SUB

SUB XMSINIT ()
XMS.ENTRIE ES%, BX%

XMSSEG% = ES%
XMSADD% = BX%
XMSCALL$ = MKI$(BX%) + MKI$(ES%)




   ASM$ = ""
   ASM$ = ASM$ + CHR$(&H55)                           'PUSH BP
   ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)              'MOV BP,SP
   ASM$ = ASM$ + CHR$(&H50)                           'PUSH AX
   ASM$ = ASM$ + CHR$(&HB8) + CHR$(&H0) + CHR$(&H43)  'MOV AX,4300
   ASM$ = ASM$ + CHR$(&HCD) + CHR$(&H2F)              'INT 2F
   ASM$ = ASM$ + CHR$(&H3C) + CHR$(&H80)              'CMP AL,80
   ASM$ = ASM$ + CHR$(&H74) + CHR$(&H2)               'JZ 2
   ASM$ = ASM$ + CHR$(&H31) + CHR$(&HC0)              'XOR AX,AX
   ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)  'MOV BX,[BP+06]
   ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)               'MOV [BX],AX
   ASM$ = ASM$ + CHR$(&H58)                           'POP AX
   ASM$ = ASM$ + CHR$(&H5D)                           'POP BP
   ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H2) + CHR$(&H0)   'RETF 2
XMSSUB$(XMS.E) = ASM$ 'DETECT

  ASM$ = ""
  ASM$ = ASM$ + CHR$(&H55)                            'PUSH BP
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)               'MOV BP,SP
  ASM$ = ASM$ + CHR$(&H50)                            'PUSH AX
  ASM$ = ASM$ + CHR$(&H53)                            'PUSH BX
  ASM$ = ASM$ + CHR$(&H52)                            'PUSH DX

  ASM$ = ASM$ + CHR$(&HB4) + CHR$(&H8)                'MOV AH,0800 QUERY FREE XMS
  ASM$ = ASM$ + CHR$(&H9A) + XMSCALL$                'CALL DRIVER
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H17)               'MOV [BX],DX
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)   'MOV BX,[BP+08]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX

  ASM$ = ASM$ + CHR$(&H5A)                            'POP DX
  ASM$ = ASM$ + CHR$(&H5B)                            'POP BX
  ASM$ = ASM$ + CHR$(&H58)                            'POP AX
  ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
  ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)    'RETF 4
XMSSUB$(XMS.F) = ASM$ 'XMS.FREE

  ASM$ = ""
  ASM$ = ASM$ + CHR$(&H55)
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)
  ASM$ = ASM$ + CHR$(&H50)
  ASM$ = ASM$ + CHR$(&H52)

  ASM$ = ASM$ + CHR$(&HB4) + CHR$(&H9)                'MOV AH,9
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H17)               'MOV DX,[BX] 1 KB BLOCKS
  ASM$ = ASM$ + CHR$(&H9A) + XMSCALL$                'CALL DRIVER
  ASM$ = ASM$ + CHR$(&H9) + CHR$(&HC0)                'OR AX,AX
  ASM$ = ASM$ + CHR$(&H75) + CHR$(&H2)                'JNZ 2
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HDA)               'MOV DX,BX
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H17)               'MOV [BX],DX
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)   'MOV BX,[BP+08]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX

  ASM$ = ASM$ + CHR$(&H5A)                            'POP AX
  ASM$ = ASM$ + CHR$(&H58)                            'POP DX
  ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
  ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)    'RETF 4

XMSSUB$(XMS.A) = ASM$ 'XMS.ALLOC
  ASM$ = ""
  ASM$ = ASM$ + CHR$(&H55)                            'push bp
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)               'mov bp,sp
  ASM$ = ASM$ + CHR$(&H50)                            'push ax
  ASM$ = ASM$ + CHR$(&H52)                            'push dx

  ASM$ = ASM$ + CHR$(&HB4) + CHR$(&HF)                'MOV AH,F
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H17)               'MOV DX,[BX] XMS handle
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5F) + CHR$(&H8)   'MOV BX,[BP+08]
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H1F)               'MOV BX,[BX]
  ASM$ = ASM$ + CHR$(&H9A) + XMSCALL$                'CALL DRIVER
  ASM$ = ASM$ + CHR$(&H9) + CHR$(&HC0)                'OR AX,AX
  ASM$ = ASM$ + CHR$(&H75) + CHR$(&H2)                'JNZ 2
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HD9)               'MOV AX,BX
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX


  ASM$ = ASM$ + CHR$(&H5A)                            'POP dX
  ASM$ = ASM$ + CHR$(&H58)                            'POP aX
  ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
  ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)    'RETF 4
XMSSUB$(XMS.R) = ASM$ 'REALLOC

  ASM$ = ""
  ASM$ = ASM$ + CHR$(&H55)                            'PUSH BP
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)               'MOV BP,SP
  ASM$ = ASM$ + CHR$(&H50)                            'PUSH AX
  ASM$ = ASM$ + CHR$(&H52)                            'PUSH DX

  ASM$ = ASM$ + CHR$(&HB4) + CHR$(&HA)                'MOV AH,A
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H17)               'MOV DX,[BX] HANDLE
  ASM$ = ASM$ + CHR$(&H9A) + XMSCALL$                'CALL DRIVER
  ASM$ = ASM$ + CHR$(&H9) + CHR$(&HC0)                'OR AX,AX
  ASM$ = ASM$ + CHR$(&H75) + CHR$(&H2)                'JNZ 2
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HD9)               'MOV AX,BX
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX

  ASM$ = ASM$ + CHR$(&H5A)                            'POP dX
  ASM$ = ASM$ + CHR$(&H58)                            'POP aX
  ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
  ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H2) + CHR$(&H0)    'RETF 2
XMSSUB$(XMS.D) = ASM$ ' DEALLOC

  ASM$ = ""
  ASM$ = ASM$ + CHR$(&H55)                            'push bp
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)               'mov bp,sp
  ASM$ = ASM$ + CHR$(&H50)                            'push ax
  ASM$ = ASM$ + CHR$(&H52)                            'push dx

  ASM$ = ASM$ + CHR$(&HB4) + CHR$(&HC)                'MOV AH,C
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H17)               'MOV DX,[BX] handle
  ASM$ = ASM$ + CHR$(&H9A) + XMSCALL$                'CALL DRIVER
  ASM$ = ASM$ + CHR$(&H9) + CHR$(&HC0)                'OR AX,AX
  ASM$ = ASM$ + CHR$(&H75) + CHR$(&H4)                'JNZ 4
  ASM$ = ASM$ + CHR$(&H30) + CHR$(&HFF)               'XOR BH,BH  'to zero on error
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HDA)               'MOV DX,BX  'and put in DX
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HD8)               'mov ax,bx  'need bx
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H17)               'MOV [BX],DX
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)   'MOV BX,[BP+08]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX

  ASM$ = ASM$ + CHR$(&H5A)                            'POP AX
  ASM$ = ASM$ + CHR$(&H58)                            'POP DX
  ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
  ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)    'RETF 4
XMSSUB$(XMS.L) = ASM$

  ASM$ = ""
  ASM$ = ASM$ + CHR$(&H55)                            'push bp
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)               'mov bp,sp
  ASM$ = ASM$ + CHR$(&H50)                            'push ax
  ASM$ = ASM$ + CHR$(&H52)                            'push dx

  ASM$ = ASM$ + CHR$(&HB4) + CHR$(&HD)                'MOV AH,D
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H17)               'MOV DX,[BX] handle
  ASM$ = ASM$ + CHR$(&H9A) + XMSCALL$                'CALL DRIVER
  ASM$ = ASM$ + CHR$(&H9) + CHR$(&HC0)                'OR AX,AX
  ASM$ = ASM$ + CHR$(&H75) + CHR$(&H2)                'JNZ 2
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HD9)               'MOV AX,BX
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX

  ASM$ = ASM$ + CHR$(&H5A)                            'POP AX
  ASM$ = ASM$ + CHR$(&H58)                            'POP DX
  ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
  ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H2) + CHR$(&H0)    'RETF 2
XMSSUB$(XMS.U) = ASM$

  ASM$ = ""
  ASM$ = ASM$ + CHR$(&H55)                            'Push AX
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HE5)               'MOV BP,SP
  ASM$ = ASM$ + CHR$(&H56)                            'Push SI
  ASM$ = ASM$ + CHR$(&H1E)                            'Push DS


  ASM$ = ASM$ + CHR$(&HB4) + CHR$(&HB)                'MOV AH,B
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6)   'MOV BX,[BP+06]
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H37)               'MOV SI,[BX] OFFSET
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)   'MOV BX,[BP+08]
  ASM$ = ASM$ + CHR$(&H8E) + CHR$(&H1F)               'MOV DS,[BX] SEGMENT
  ASM$ = ASM$ + CHR$(&H9A) + XMSCALL$                'CALL DRIVER
  ASM$ = ASM$ + CHR$(&H9) + CHR$(&HC0)                'OR AX,AX 'SUCSES ?
  ASM$ = ASM$ + CHR$(&H74) + CHR$(&H2)                'JZ 2    'NO ? JUMP
  ASM$ = ASM$ + CHR$(&H31) + CHR$(&HDB)               'XOR BX,BX
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&HD8)               'MOV AX,BX
  ASM$ = ASM$ + CHR$(&H1F)                            'POP DS  'have to restore before [bx] is adressed
  ASM$ = ASM$ + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8)   'MOV BX,[BP+08]
  ASM$ = ASM$ + CHR$(&H89) + CHR$(&H7)                'MOV [BX],AX

  ASM$ = ASM$ + CHR$(&H5E)                            'POP SI
  ASM$ = ASM$ + CHR$(&H5D)                            'POP BP
  ASM$ = ASM$ + CHR$(&HCA) + CHR$(&H4) + CHR$(&H0)    'RETF 4
XMSSUB$(XMS.M) = ASM$

END SUB

