DECLARE SUB MR.Id (A%)
DECLARE SUB mc.id (A AS ANY)
DECLARE SUB M.ADCx (A%)
DECLARE SUB M.ANDx (A%)
DECLARE SUB M.EORx (A%)
DECLARE SUB M.ORAx (A%)
DECLARE SUB IO.write (A%, B%)
DECLARE SUB BANK_SET (A%, B%)
DECLARE SUB T_INIT ()
DECLARE FUNCTION MCZp% ()
DECLARE FUNCTION MCZx% ()
DECLARE SUB M.RMB (A%)
DECLARE SUB M.SMB (A%)
DECLARE SUB mc.ix (RG AS ANY)
DECLARE SUB mc.iy (RG AS ANY)
DECLARE SUB mc.zx (RG AS ANY)
DECLARE SUB codes (I%)
DECLARE FUNCTION exec6502% ()
DECLARE FUNCTION M.DEC% (A%)
DECLARE SUB mc.ab (A AS ANY)
DECLARE SUB mc.ay (A AS ANY)
DECLARE SUB mc.zp (RG AS ANY)
DECLARE SUB mc.zy (RG AS ANY)
DECLARE SUB Wr6502 (A%, B%)
DECLARE FUNCTION both% (A AS ANY)
DECLARE SUB mc.ax (A AS ANY)
DECLARE FUNCTION m.inc% (A%)
DECLARE SUB M.JR ()
DECLARE SUB M.POP (A AS INTEGER)
DECLARE FUNCTION low% (A%)
DECLARE FUNCTION high% (A%)
DECLARE SUB lows (A%, B%)
DECLARE FUNCTION op6502! (A%)
DECLARE SUB highs (A%, B%)
DECLARE SUB M.PUSH (A%)
DECLARE SUB M.LDWORD (A AS ANY)
DECLARE FUNCTION rd6502% (A%)
DECLARE SUB M.FL (A%)
DECLARE SUB MR.Zp (A%)
DECLARE SUB M.BIT (A%)
DECLARE SUB MR.Ab (A%)
DECLARE SUB M.ORA (A%)
DECLARE SUB MM.Zp (A%)
DECLARE SUB M.AND (A%)
DECLARE SUB M.EOR (A%)
DECLARE SUB M.ADC (A%)
DECLARE SUB MW.Zp (A%)
DECLARE SUB M.CMP (A%, B%)
DECLARE SUB M.SBC (A%)
DECLARE SUB MM.Ab (A%)
DECLARE SUB MW.Ab (A%)
DECLARE SUB MR.Im (A%)
DECLARE SUB MR.Zx (A%)
DECLARE SUB mm.zx (A%)
DECLARE SUB MW.Zx (A%)
DECLARE SUB mw.zy (A%)
DECLARE SUB mr.zy (A%)
DECLARE SUB MR.Ay (A%)
DECLARE SUB MR.Ax (A%)
DECLARE SUB mm.ax (A%)
DECLARE SUB mw.ay (A%)
DECLARE SUB MW.Ax (A%)
DECLARE SUB MR.Ix (A%)
DECLARE SUB MR.Iy (A%)
DECLARE SUB mw.ix (A%)
DECLARE SUB mw.iy (A%)
DECLARE SUB m.asll (A%)
DECLARE SUB m.roll (A%)
DECLARE SUB m.lsrr (A%)
DECLARE SUB m.rorr (A%)
DEFINT A-Z


TYPE bb  'change this around for lsb fists, last
l AS INTEGER
h AS INTEGER
END TYPE


TYPE pcc
 W AS INTEGER
 B AS bb
END TYPE
TYPE regg
 P AS INTEGER        'on byte register
 A AS INTEGER
 X AS INTEGER
 Y AS INTEGER
 s AS INTEGER
 PC AS pcc
 irequest AS INTEGER
 icount AS INTEGER
 IBackup AS INTEGER
 afterCLI AS INTEGER
 iperiod AS INTEGER
END TYPE


'byte = unsigned char (1)
'word = unsigned short (2)
'offset = signed char

'type pair
' word w
' int b {byte l,h}
'end type
' n
' n.w
' n.b (n.b.l,n.b.h)


                       '       /* 6502 status flags:         */
CONST C.FLAG = &H1     '       /* 1: Carry occured           */
CONST Z.FLAG = &H2     '       /* 1: Result is zero          */
CONST I.FLAG = &H4     '       /* 1: Interrupts disabled     */
CONST D.FLAG = &H8     '       /* 1: Decimal mode            */
CONST b.flag = &H10    '       /* Break [0 on stk after int] */
CONST r.flag = &H20    '       /* Always 1                   */
CONST V.FLAG = &H40    '       /* 1: Overflow occured        */
CONST N.FLAG = &H80    '       /* 1: Result is negative      */

'                      '       /* Loop6502() returns:        */
CONST int.none = 0     '       /* No interrupt required      */
CONST INT.IRQ = 1      '       /* Standard IRQ interrupt     */
CONST INT.NMI = 2      '       /* Non-maskable interrupt     */
CONST INT.QUIT = 3     '       /* Exit the emulation         */


DIM SHARED REG AS regg, K AS pcc, j AS pcc, Cycles%(255), zntable%(255), I
DIM SHARED m.mpr(), rdram(), adrRam()



RESTORE cycledata
FOR ii = 0 TO 255: READ Cycles%(ii): NEXT ii
RESTORE zntabledata
FOR ii = 0 TO 255: READ zntable%(ii): NEXT ii
END


cycledata:
'static byte Cycles[256] =
DATA  7,6,2,8,3,3,5,5,3,2,2,2,4,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
DATA  6,6,2,8,3,3,5,5,4,2,2,2,4,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
DATA  6,6,2,8,3,3,5,5,3,2,2,2,3,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
DATA  6,6,2,8,3,3,5,5,4,2,2,2,5,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
DATA  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4
DATA  2,6,2,6,4,4,4,4,2,5,2,5,5,5,5,5
DATA  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4
DATA  2,5,2,5,4,4,4,4,2,4,2,5,4,4,4,4
DATA  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
DATA  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7



zntabledata:
'byte ZNTable[256] =

'DATA  Z.FLAG,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

'new
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128









'old
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG

SUB BANK_SET (A%, B%)
END SUB

FUNCTION both (A AS bb)
both% = CVI(CHR$(ASC(MKI$(A.l))) + CHR$(ASC(MKI$(A.h))))
END FUNCTION

SUB codes (I)
SELECT CASE I
CASE &H10' /* BPL * REL */
   IF REG.P AND N.FLAG THEN REG.PC.W = REG.PC.W + 1:  ELSE : M.JR

CASE &H30' /* BMI * REL */
  IF P.R AND N.FLAG THEN M.JR:  ELSE : PC.W.R = PC.W.R + 1

CASE &HD0' /* BNE * REL */
  IF REG.P AND Z.FLAG THEN REG.PC.W = REG.PC.W + 1:  ELSE : M.JR

CASE &HF0' /* BEQ * REL */
  IF NOT (REG.P AND Z.FLAG) THEN REG.PC.W = REG.PC.W + 1:   ELSE : M.JR


CASE &H90' /* BCC * REL */
  IF REG.P AND C.FLAG THEN REG.PC.W = REG.PC.W + 1:  ELSE : M.JR


CASE &HB0' /* BCS * REL */
  IF NOT (REG.P AND C.FLAG) THEN REG.PC.W = REG.PC.W + 1:  ELSE : M.JR


CASE &H50' /* BVC * REL */
  IF REG.P AND V.FLAG THEN REG.PC.W = REG.PC.W + 1:  ELSE : M.JR


CASE &H70' /* BVS * REL */
  IF NOT (REG.P AND V.FLAG) THEN : REG.PC.W = REG.PC.W + 1:  ELSE : M.JR



CASE &H40' /* RTI */
  M.POP REG.P
  REG.P = REG.P OR r.flag
  M.POP REG.PC.B.l
  M.POP REG.PC.B.h



CASE &H60'/* RTS */
   M.POP REG.PC.B.l
   M.POP REG.PC.B.h
   REG.PC.W = REG.PC.W + 1



CASE &H20'/* JSR $ssss ABS */
   K.B.l = op6502(REG.PC.W)
   REG.PC.W = REG.PC.W + 1
   K.B.h = op6502(REG.PC.W)
   M.PUSH REG.PC.B.h
   M.PUSH REG.PC.B.l
   REG.PC = K

CASE &H4C'/* JMP $ssss ABS */
 M.LDWORD K
 REG.PC = K

CASE &H6C'/* JMP ($ssss) ABDINDIR */
   M.LDWORD K
   REG.PC.B.l = rd6502(K.W)
   K.W = K.W + 1
   REG.PC.B.h = rd6502(K.W)


CASE &H0: '/* BRK */
   REG.PC.W = REG.PC.W + 1
   M.PUSH REG.PC.B.h
   M.PUSH REG.PC.B.l
   M.PUSH REG.P OR b.flag
   REG.P = (REG.P OR I.FLAG) AND NOT (D.FLAG)
   REG.PC.B.l = rd6502(&HFFFE)
   REG.PC.B.h = rd6502(&HFFFF)


CASE &H58: '/* CLI */
   IF (REG.irequest <> int.none) AND ((REG.P AND I.FLAG) <> 0) THEN
   REG.afterCLI = 1
   REG.IBackup = REG.icount
   REG.icount = 1
   END IF
   REG.P = REG.P AND NOT (I.FLAG)

CASE &H28'/* PLP */
   M.POP I
   IF (REG.irequest <> int.mode) AND ((I XOR REG.P) AND NOT (I) AND I.FLAG) THEN
     REG.afterCLI = 1
     REG.IBackup = r.icound
     REG.icount = 1
   END IF
   REG.P = I OR r.flag



CASE &H8 '/* PHP */
            M.PUSH REG.P


CASE &H18'/* CLC */
            REG.P = REG.P AND NOT (C.FLAG)

CASE &HB8'/* CLV */
            REG.P = REG.P AND NOT (V.FLAG)

CASE &HD8'/* CLD */
            REG.P = REG.P AND NOT (D.FLAG)

CASE &H38':/* SEC */
            REG.P = REG.P OR C.FLAG

CASE &HF8':/* SED */
            REG.P = REG.P OR D.FLAG

CASE &H78':/* SEI */
            REG.P = REG.P OR I.FLAG


CASE &H48':/* PHA */
            M.PUSH REG.A
CASE &H68':/* PLA */
            M.POP REG.A: M.FL REG.A
CASE &H98':/* TYA */
            REG.A = REG.Y: M.FL REG.A
CASE &HA8':/* TAY */
            REG.Y = REG.A: M.FL REG.Y
CASE &HC8':/* INY */
            REG.Y = REG.Y + 1: M.FL REG.Y
CASE &H88':/* DEY */
            REG.Y = REG.Y - 1: M.FL REG.Y
CASE &H8A':/* TXA */
            REG.A = REG.X: M.FL REG.A
CASE &HAA':/* TAX */
            REG.X = REG.A: M.FL REG.X
CASE &HE8':/* INX */
            REG.X = REG.X + 1: M.FL REG.X
CASE &HCA':/* DEX */
            REG.X = REG.X - 1: M.FL REG.X

CASE &HEA':/* NOP */

CASE &H9A':/* TXS */
            ref.s = REG.X
CASE &HBA':/* TSX */
            REG.X = REG.s
CASE &H24':/* BIT $ss ZP */
            MR.Zp I: M.BIT I
CASE &H2C':/* BIT $ssss ABS */
            MR.Ab I: M.BIT I

CASE &H5 ':/* ORA $ss ZP */
            MR.Zp I: M.ORA I

CASE &H6 ':/* ASL $ss ZP */
            MM.Zp m.asl

CASE &H25':/* AND $ss ZP */
            MR.Zp I: M.AND I

CASE &H26':/* ROL $ss ZP */
            MR.Zp m.rol

CASE &H45':/* EOR $ss ZP */
            MR.Zp I: M.EOR I

CASE &H46':/* LSR $ss ZP */
            MM.Zp m.lsr

CASE &H65':/* ADC $ss ZP */
            MR.Zp I: M.ADC I


CASE &H66':/* ROR $ss ZP */
            MM.Zp m.ror

CASE &H84':/* STY $ss ZP */
            MW.Zp REG.Y

CASE &H85':/* STA $ss ZP */
            MW.Zp REG.A

CASE &H86':/* STX $ss ZP */
            MW.Zp REG.X

CASE &HA4': /* LDY $ss ZP */
            MR.Zp REG.Y: M.FL REG.Y

CASE &HA5': /* LDA $ss ZP */
            MR.Zp REG.A: M.FL REG.A

CASE &HA6': /* LDX $ss ZP */
            MR.Zp REG.X: M.FL REG.X

CASE &HC4': /* CPY $ss ZP */
            MR.Zp I: M.CMP REG.Y, I

CASE &HC5': /* CMP $ss ZP */
            MR.Zp I: M.CMP REG.A, I

CASE &HC6': /* DEC $ss ZP */
'error
'            mr.zp m.dec

CASE &HE4': /* CPX $ss ZP */
            MR.Zp I: M.CMP REG.X, I

CASE &HE5': /* SBC $ss ZP */
            MR.Zp I: M.SBC I

CASE &HE6': /* INC $ss ZP */
'            mm.zp m.inc
'error
CASE &HD ': /* ORA $ssss ABS */
            MR.Ab I: M.ORA I

CASE &HE ': /* ASL $ssss ABS */
            MM.Ab m.asl
CASE &H2D': /* AND $ssss ABS */
            MR.Ab I: M.AND I

CASE &H2E':/* ROL $ssss ABS */
            MM.Ab m.rol
CASE &H4D': /* EOR $ssss ABS */
            MR.Ab I: M.EOR I
CASE &H4E': /* LSR $ssss ABS */
            MM.Ab m.lsr

CASE &H6D': /* ADC $ssss ABS */
            MR.Ab I: M.ADC I
CASE &H6E': /* ROR $ssss ABS */
            MM.Ab m.ror
CASE &H8C': /* STY $ssss ABS */
            MW.Ab REG.Y
CASE &H8D': /* STA $ssss ABS */
            MW.Ab REG.A
CASE &H8E': /* STX $ssss ABS */
            MW.Ab REG.X

CASE &HAC': /* LDY $ssss ABS */
            MR.Ab REG.Y: M.FL REG.Y
CASE &HAD': /* LDA $ssss ABS */
            MR.Ab REG.A: M.FL REG.A

CASE &HAE': /* LDX $ssss ABS */
            MR.Ab REG.X: M.FL REG.X

CASE &HCC': /* CPY $ssss ABS */
            MR.Ab I: M.CMP REG.Y, I

CASE &HCD': /* CMP $ssss ABS */
            MR.Ab I: M.CMP REG.A, I

CASE &HCE': /* DEC $ssss ABS */
'error
'            mr.ab m.dec

CASE &HEC': /* CPX $ssss ABS */
            MR.Ab I: M.CMP REG.X, I

CASE &HED': /* SBC $ssss ABS */
            MR.Ab I: M.SBC I

CASE &HEE': /* INC $ssss ABS */
'error
'            mm.ab m.inc

CASE &H9 ': /* ORA #$ss IMM */
            MR.Im I: M.ORA I
CASE &H29': /* AND #$ss IMM */
            MR.Im I: M.AND I
CASE &H49': /* EOR #$ss IMM */
            MR.Im I: M.EOR I
CASE &H69': /* ADC #$ss IMM */
            MR.Im I: M.ADC I

CASE &HA0': /* LDY #$ss IMM */
            MR.Im REG.Y: M.FL REG.Y
CASE &HA2': /* LDX #$ss IMM */
            MR.Im REG.X: M.FL REG.X

CASE &HA9': /* LDA #$ss IMM */
            MR.Im REG.A: M.FL REG.A

CASE &HC0': /* CPY #$ss IMM */
            MR.Im I: M.CMP REG.Y, I
CASE &HC9': /* CMP #$ss IMM */
            MR.Im I: M.CMP REG.A, I

CASE &HE0': /* CPX #$ss IMM */
            MR.Im I: M.CMP REG.X, I

CASE &HE9': /* SBC #$ss IMM */
            MR.Im I: M.SBC I
CASE &H15': /* ORA $ss,x ZP,x */
            MR.Zx I: M.ORA I
CASE &H16': /* ASL $ss,x ZP,x */
            MR.Zx m.asl

CASE &H35': /* AND $ss,x ZP,x */
            MR.Zx I: M.AND I

CASE &H36': /* ROL $ss,x ZP,x */
            mm.zx m.rol
CASE &H55': /* EOR $ss,x ZP,x */
            MR.Zx I: M.EOR I
CASE &H56': /* LSR $ss,x ZP,x */
            mm.zx m.lsr
CASE &H75': /* ADC $ss,x ZP,x */
            MR.Zx I: M.ADC I
CASE &H76': /* ROR $ss,x ZP,x */
            mm.zx m.ror
CASE &H94': /* STY $ss,x ZP,x */
            MW.Zx REG.Y
CASE &H95': /* STA $ss,x ZP,x */
            MW.Zx REG.A
CASE &H96': /* STX $ss,y ZP,y */
            mw.zy REG.X
CASE &HB4': /* LDY $ss,x ZP,x */
            MR.Zx REG.Y: M.FL REG.Y
CASE &HB5': /* LDA $ss,x ZP,x */
            MR.Zx REG.A: M.FL REG.A

CASE &HB6': /* LDX $ss,y ZP,y */
            mr.zy REG.X: M.FL REG.X

CASE &HD5': /* CMP $ss,x ZP,x */
            MR.Zx I: M.CMP REG.A, I

CASE &HD6': /* DEC $ss,x ZP,x */
'error
'            mm.zx m.dec

CASE &HF5': /* SBC $ss,x ZP,x */
            MR.Zx I: M.SBC I
CASE &HF6': /* INC $ss,x ZP,x */
'error
'            mm.zx m.inc

CASE &H19': /* ORA $ssss,y ABS,y */
            MR.Ay I: M.ORA I
CASE &H1D': /* ORA $ssss,x ABS,x */
            MR.Ax I: M.ORA I
CASE &H1E': /* ASL $ssss,x ABS,x */
            mm.ax m.asl
CASE &H39': /* AND $ssss,y ABS,y */
            MR.Ay I: M.AND I
CASE &H3D': /* AND $ssss,x ABS,x */
            MR.Ax I: M.AND I
CASE &H3E': /* ROL $ssss,x ABS,x */
            mm.ax m.rol
CASE &H59': /* EOR $ssss,y ABS,y */
            MR.Ay I: M.EOR I
CASE &H5D': /* EOR $ssss,x ABS,x */
            MR.Ax I: M.EOR I
CASE &H5E': /* LSR $ssss,x ABS,x */
            mm.ax m.lsr
CASE &H79': /* ADC $ssss,y ABS,y */
            MR.Ay I: M.ADC I
CASE &H7D': /* ADC $ssss,x ABS,x */
            MR.Ax I: M.ADC I
CASE &H7E': /* ROR $ssss,x ABS,x */
            mm.ax m.ror
CASE &H99': /* STA $ssss,y ABS,y */
            mw.ay REG.A
CASE &H9D': /* STA $ssss,x ABS,x */
            MW.Ax REG.A
CASE &HB9': /* LDA $ssss,y ABS,y */
            MR.Ay REG.A: M.FL REG.A
CASE &HBC': /* LDY $ssss,x ABS,x */
            MR.Ax REG.Y: M.FL REG.Y

CASE &HBD': /* LDA $ssss,x ABS,x */
            MR.Ax REG.A: M.FL REG.A

CASE &HBE': /* LDX $ssss,y ABS,y */
            MR.Ay REG.X: M.FL REG.X

CASE &HD9': /* CMP $ssss,y ABS,y */
            MR.Ay I: M.CMP REG.A, I

CASE &HDD': /* CMP $ssss,x ABS,x */
            MR.Ax I: M.CMP REG.A, I

CASE &HDE': /* DEC $ssss,x ABS,x */
'error
'            mm.ax m.dec

CASE &HF9': /* SBC $ssss,y ABS,y */
            MR.Ay I: M.SBC I
CASE &HFD': /* SBC $ssss,x ABS,x */
            MR.Ax I: M.SBC I
CASE &HFE': /* INC $ssss,x ABS,x */
'error
'            mm.ax m.inc
CASE &H1 ': /* ORA ($ss,x) INDEXINDIR */
            MR.Ix I: M.ORA I
CASE &H11': /* ORA ($ss),y INDIRINDEX */
            MR.Iy I: M.ORA I
CASE &H21': /* AND ($ss,x) INDEXINDIR */
            MR.Ix I: M.AND I
CASE &H31': /* AND ($ss),y INDIRINDEX */
            MR.Iy I: M.AND I
CASE &H41': /* EOR ($ss,x) INDEXINDIR */
            MR.Ix I: M.EOR I
CASE &H51': /* EOR ($ss),y INDIRINDEX */
            MR.Iy I: M.EOR I
CASE &H61': /* ADC ($ss,x) INDEXINDIR */
            MR.Ix I: M.ADC I
CASE &H71': /* ADC ($ss),y INDIRINDEX */
            MR.Iy I: M.ADC I
CASE &H81': /* STA ($ss,x) INDEXINDIR */
            mw.ix REG.A
CASE &H91': /* STA ($ss),y INDIRINDEX */
            mw.iy REG.A
CASE &HA1': /* LDA ($ss,x) INDEXINDIR */
            MR.Ix REG.A: M.FL REG.A
CASE &HB1': /* LDA ($ss),y INDIRINDEX */
            MR.Iy REG.A: M.FL REG.A

CASE &HC1': /* CMP ($ss,x) INDEXINDIR */
            MR.Ix I: M.CMP REG.A, I

CASE &HD1': /* CMP ($ss),y INDIRINDEX */
            MR.Iy I: M.CMP REG.A, I

CASE &HE1': /* SBC ($ss,x) INDEXINDIR */
            MR.Ix I: M.SBC I

CASE &HF1': /* SBC ($ss),y INDIRINDEX */
            MR.Iy I: M.SBC I


CASE &HA ': /* ASL a ACC */
'error
            m.asll REG.A
CASE &H2A': /* ROL a ACC */
'error
            m.roll REG.A
CASE &H4A': /* LSR a ACC */
'error
            m.lsrr REG.A
CASE &H6A': /* ROR a ACC */
'error
            m.rorr REG.A

CASE ELSE
'default:
'  if(R->TrapBadOps)
'    printf
'    (
'      "[M6502 %lX] Unrecognized instruction: $%02X at PC=$%04X\n",
'      R->User,Op6502(R->PC.W-1),(word)(R->PC.W-1)
'    );
'  break;
END SELECT

END SUB

FUNCTION exec6502 ()
'int sub ?

'/** Exec6502() ***********************************************/
'/** This function will execute a single 6502 opcode. It     **/
'/** will then return next PC, and current register values   **/
'/** in R.                                                   **/
'/*************************************************************/
'word exec6502(M6502 * R)
'{
'  register pair J,K;
'  register byte I;
'
'  I=Op6502(R->PC.W++);
REG.PC.W = REG.PC.W + 1
I = op6502(REG.PC.W)


'  R->ICount-=Cycles[I];
REG.icount = REG.icount - Cycles%(I)

'  switch (I)
'  {
'#include "Codes.h"
'  }
codes I

'
'  /* We are done */
'  return(R->PC.W);
'}
'
exec6502 = REG.PC.W

END FUNCTION

SUB hucodes (I)
SELECT CASE I
CASE &HD4'/* CSH set clock highspeed */
CASE &H54'/* CSL set clock lowspeed */

CASE &H44: '/* BSR * REL */
           M.PUSH REG.PC.B.h
           M.PUSH REG.PC.B.l

CASE &H80: '/* BRA * REL */

'error
'          reg.pc.w= reg.pc.w + (offset)op6502(reg.pc.w) + 1


CASE &H7C: '/* JMP ($ssss,x) */
        M.LDWORD K: K.W = K.W + REG.X
        REG.PC.B.l = op6502(K.W)
        REG.PC.B.h = op6502(K.W + 1)

CASE &HDA: M.PUSH REG.X  '  /* PHX */

CASE &H5A: M.PUSH REG.Y '               /* PHY */
CASE &HFA: M.POP REG.X: M.FL REG.X '    /* PLX */
CASE &H7A: M.POP REG.Y: M.FL REG.Y'      /* PLY */

CASE &H62: REG.A = 0' /* CLA */
CASE &H82: REG.X = 0' /* CLX */
CASE &HC2: REG.Y = 0' /* CLY */

CASE &H2: I = REG.X: REG.X = REG.Y: REG.Y = I'  /* SXY */
CASE &H22: I = REG.A: REG.A = REG.X: REG.X = I'  /* SAX */
CASE &H42: I = REG.A: REG.A = REG.Y: REG.Y = I'  /* SAY */

CASE &H3A
 'error
 'M.DEC reg.a                   ' /* DEC A */

CASE &H1A:
  'error
  'M_INC reg.a                   ' /* INC A */

CASE &H72: MR.Id I: M.ADC I               '/* ADC ($ss) INDIR */
CASE &H32: MR.Id I: M.AND I               '/* AND ($ss) INDIR */
CASE &HD2: MR.Id I: M.CMP REG.A, I        '/* CMP ($ss) INDIR */
CASE &H52: MR.Id I: M.EOR I               '/* EOR ($ss) INDIR */
CASE &HB2: MR.Id REG.A: M.FL REG.A        '/* LDA ($ss) INDIR */
CASE &H12: MR.Id I: M.ORA I               '/* ORA ($ss) INDIR */
CASE &H92: mc.id j: Wr6502 j.W, REG.A     '/* STA ($ss) INDIR */
CASE &HF2: MR.Id I: M.SBC I             '  /* SBC ($ss) INDIR */

CASE &H89: MR.Im I: M.BIT (I)'              /* BIT #$ss IMM */
CASE &H34: MR.Zx I: M.BIT (I)'              /* BIT $ss,x ZP,x */
CASE &H3C: MR.Ax I: M.BIT (I)'              /* BIT $ssss,x ABS,x */

CASE &H64: MW.Zp &H0            '          /* STZ $ss ZP */
CASE &H74: MW.Zx &H0            '          /* STZ $ss,x ZP,x */
CASE &H9C: MW.Ab &H0            '          /* STZ $ssss ABS */
CASE &H9E: MW.Ax &H0            '          /* STZ $ssss,x ABS,x */

CASE &HF4: '/* SET */
        I = op6502(REG.PC.W)
        REG.PC.W = REG.PC.W + 1
        cycle = cycle + Cycles(I) + 3
        SELECT CASE I
        CASE &H65: MR.Zp I: M.ADCx I'       /* ADC $ss ZP */
        CASE &H6D: MR.Ab I: M.ADCx I'       /* ADC $ssss ABS */
        CASE &H69: MR.Im I: M.ADCx I'       /* ADC #$ss IMM */
        CASE &H75: MR.Zx I: M.ADCx I'       /* ADC $ss,x ZP,x */
        CASE &H79: MR.Ay I: M.ADCx I'       /* ADC $ssss,y ABS,y */
        CASE &H7D: MR.Ax I: M.ADCx I'       /* ADC $ssss,x ABS,x */
        CASE &H61: MR.Ix I: M.ADCx I'       /* ADC ($ss,x) INDEXINDIR */
        CASE &H71: MR.Iy I: M.ADCx I'       /* ADC ($ss),y INDIRINDEX */
        CASE &H72: MR.Id I: M.ADCx I'       /* ADC ($ss) INDIR */

        CASE &H25: MR.Zp I: M.ANDx I'       /* AND $ss ZP */
        CASE &H2D: MR.Ab I: M.ANDx I'       /* AND $ssss ABS */
        CASE &H29: MR.Im I: M.ANDx I'       /* AND #$ss IMM */
        CASE &H35: MR.Zx I: M.ANDx I'       /* AND $ss,x ZP,x */
        CASE &H39: MR.Ay I: M.ANDx I'       /* AND $ssss,y ABS,y */
        CASE &H3D: MR.Ax I: M.ANDx I'       /* AND $ssss,x ABS,x */
        CASE &H21: MR.Ix I: M.ANDx I'       /* AND ($ss,x) INDEXINDIR */
        CASE &H31: MR.Iy I: M.ANDx I'       /* AND ($ss),y INDIRINDEX */
        CASE &H32: MR.Id I: M.ANDx I'       /* AND ($ss) INDIR */

        CASE &H45: MR.Zp I: M.EORx I'       /* EOR $ss ZP */
        CASE &H4D: MR.Ab I: M.EORx I'       /* EOR $ssss ABS */
        CASE &H49: MR.Im I: M.EORx I'       /* EOR #$ss IMM */
        CASE &H55: MR.Zx I: M.EORx I'       /* EOR $ss,x ZP,x */
        CASE &H59: MR.Ay I: M.EORx I'       /* EOR $ssss,y ABS,y */
        CASE &H5D: MR.Ax I: M.EORx I'       /* EOR $ssss,x ABS,x */
        CASE &H41: MR.Ix I: M.EORx I'       /* EOR ($ss,x) INDEXINDIR */
        CASE &H51: MR.Iy I: M.EORx I'       /* EOR ($ss),y INDIRINDEX */
        CASE &H52: MR.Id I: M.EORx I'       /* EOR ($ss) INDIR */

        CASE &H5: MR.Zp I: M.ORAx I '       /* ORA $ss ZP */
        CASE &HD: MR.Ab I: M.ORAx I '       /* ORA $ssss ABS */
        CASE &H9: MR.Im I: M.ORAx I '       /* ORA #$ss IMM */
        CASE &H15: MR.Zx I: M.ORAx I '       /* ORA $ss,x ZP,x */
        CASE &H19: MR.Ay I: M.ORAx I '       /* ORA $ssss,y ABS,y */
        CASE &H1D: MR.Ax I: M.ORAx I '       /* ORA $ssss,x ABS,x */
        CASE &H1: MR.Ix I: M.ORAx I  '       /* ORA ($ss,x) INDEXINDIR */
        CASE &H11: MR.Iy I: M.ORAx I '       /* ORA ($ss),y INDIRINDEX */
        CASE &H12: MR.Id I: M.ORAx I '       /* ORA ($ss) INDIR */

        CASE ELSE

'default:
'        fprintf(stderr,"no sense SET\n");
'        cycle-=Cycles[I];
'                break;
'    }
'    break;

        END SELECT
CASE &H3: IO.write 0, op6502(REG.PC.W): REG.PC.W = REG.PC.W + 1'/* ST0 */
CASE &H13: IO.write 2, op6502(REG.PC.W): REG.PC.W = REG.PC.W + 1'/* ST1 */
CASE &H23: IO.write 3, op6502(REG.PC.W): REG.PC.W = REG.PC.W + 1'/* ST2 */

CASE &H43: '/* TMAi */
        I = op6502(REG.PC.W): REG.PC.W = REG.PC.W + 1

          FOR ii = 0 TO 7
              I = I \ 2 ^ 1

              IF (I AND 1) THEN EXIT FOR

          '//reg.a = Reg.MPR[ii];
          '//reg.a = Reg.MPR[ii];
          REG.A = m.mpr(ii)
          NEXT ii

CASE &H53: '/* TAMi */
        I = op6502(REG.PC.W): REG.PC.W = REG.PC.W + 1
    
         FOR ii = 0 TO 7
                I = I * 2 ^ 1
                IF (I AND 11) THEN
                        '//R->MPR[ii]=reg.a
                        '//R.MPR[ii]=reg.a
                        m.mpr(ii) = REG.A
                        BANK_SET ii, REG.A
                END IF
         NEXT ii

CASE &HC3: ' /* TDD */
        T_INIT
        DO
        Wr6502 dist, rd6502(src)
        dist = dist - 1

        src = src - 1
        length = length - 1
        LOOP WHILE length + 1
'        } while(--length);




CASE &H73: ' /* TII */
        T_INIT
        DO
             Wr6502 dist, rd6502(src)
             dist = dist + 1
             src = src + 1
        length = length - 1
        LOOP WHILE length + 1
'        } while(--length);


CASE &HE3: ' /* TIA */
        T_INIT
        DO
                Wr6502 dist, rd6502(src)
                src = src + 1

                IF NOT length THEN EXIT DO
                ' if (!(--length)):break
                length = length - 1
                Wr6502 dist + 1, rd6502(src)
                src = src + 1
'        } while(--length);
        lenght = length - 1
        LOOP WHILE length + 1


CASE &HF3: ' /* TAI */
        T_INIT
        DO
                Wr6502 dist, rd6502(src)
                dist = dist + 1
                'if (!(--length)) break;
                IF NOT length - 1 THEN EXIT DO
                Wr6502 dist, rd6502(src + 1)
                dist = dist + 1
         LOOP WHILE length - 1
'        } while(--length);

CASE &HD3: ' /* TIN */
        T_INIT
        DO
                Wr6502 dist, rd6502(src)
                src = src + 1
        LOOP WHILE length - 1

CASE &H14: MM.Zp TRB  '      /* TRB $ss ZP */
CASE &H1C: MM.Ab TRB  '      /* TRB $ssss ABS */

CASE &H4: MM.Zp TSB   '      /* TSB $ss ZP */
CASE &HC: MM.Ab TSB   '      /* TSB $ssss ABS */

CASE &H83: '/* TST #$ss,$ss IMM,ZP */
        I = op6502(REG.PC.W): j.B.l = rdram(MCZp())
        REG.PC.W = REG.PC.W + 1
'error
'        _nf=_VF=J.B.l: _ZF=I&J.B.l;

CASE &HA3: '/* TST #$ss,$ss,x IMM,ZP,x */
        I = op6502(regPC.w): j.B.l = rdram(MCZx())
        REG.PC.W = REG.PC.W + 1
'error
'        _NF=_VF=J.B.l: _ZF=I&J.B.l;
CASE &H93: '/* TST #$ss,$ssss IMM,ABS */
        I = op6502(REG.PC.W): MR.Ab j.B.l
        REG.PC.W = REG.PC.W + 1
'error
'        _NF=_VF=J.B.l; _ZF=I&J.B.l;

CASE &HB3: '/* TST #$ss,$ssss,x IMM,ABS,x */
        I = op6502(REG.PC.W): MR.Ax j.B.l
        REG.PC.W = REG.PC.W + 1
'error
'        _NF=_VF=J.B.l; _ZF=I&J.B.l;

CASE &HF: IF rdram(MCZp()) AND &H1 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR          '      /* BBRi */
CASE &H1F: IF rdram(MCZp()) AND &H2 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H2F: IF rdram(MCZp()) AND &H4 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H3F: IF rdram(MCZp()) AND &H8 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H4F: IF rdram(MCZp()) AND &H10 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H5F: IF rdram(MCZp()) AND &H20 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H6F: IF rdram(MCZp()) AND &H40 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H7F: IF rdram(MCZp()) AND &H80 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR

CASE &H8F: IF rdram(MCZp()) AND &H1 THEN M.JR:  ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1'      /* BBSi */
CASE &H9F: IF rdram(MCZp()) AND &H2 THEN M.JR:  ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HAF: IF rdram(MCZp()) AND &H4 THEN M.JR:  ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HBF: IF rdram(MCZp()) AND &H8 THEN M.JR:  ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HCF: IF rdram(MCZp()) AND &H10 THEN M.JR:  ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HDF: IF rdram(MCZp()) AND &H20 THEN M.JR:  ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HEF: IF rdram(MCZp()) AND &H40 THEN M.JR:  ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HFF: IF rdram(MCZp()) AND &H80 THEN M.JR:  ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1

'#define M_RMB(n)        *AdrRAM(MCZp())&=~n
'#define M_SMB(n)        *AdrRAM(MCZp())|=n

CASE &H7: M.RMB &H1   '        /* RMBi */
CASE &H17: M.RMB &H2  '        /* RMBi */
CASE &H27: M.RMB &H4  '        /* RMBi */
CASE &H37: M.RMB &H8  '        /* RMBi */
CASE &H47: M.RMB &H10 '        /* RMBi */
CASE &H57: M.RMB &H20 '        /* RMBi */
CASE &H67: M.RMB &H40 '        /* RMBi */
CASE &H77: M.RMB &H80 '        /* RMBi */

CASE &H87: M.SMB &H1  '        /* SMBi */
CASE &H97: M.SMB &H2  '        /* SMBi */
CASE &HA7: M.SMB &H4  '        /* SMBi */
CASE &HB7: M.SMB &H8  '        /* SMBi */
CASE &HC7: M.SMB &H10 '        /* SMBi */
CASE &HD7: M.SMB &H20 '        /* SMBi */
CASE &HE7: M.SMB &H40 '        /* SMBi */
CASE &HF7: M.SMB &H80 '        /* SMBi */
END SELECT
END SUB

SUB int6502 ()
'/** Int6502() ************************************************/
'/** This function will generate interrupt of a given type.  **/
'/** INT_NMI will cause a non-maskable interrupt. INT_IRQ    **/
'/** will cause a normal interrupt, unless I_FLAG set in R.  **/
'/*************************************************************/
'void Int6502(M6502 *R,byte Type)
'{
'  register pair J;
'
'  if((Type==INT_NMI)||((Type==INT_IRQ)&&!(R->P&I_FLAG)))
'  {
'    R->ICount-=7;
'    M_PUSH(R->PC.B.h);
'    M_PUSH(R->PC.B.l);
'    M_PUSH(R->P&~B_FLAG);
'    R->P&=~D_FLAG;
'    if(Type==INT_NMI) J.W=0xFFFA; else { R->P|=I_FLAG;J.W=0xFFFE; }
'    R->PC.B.l=Rd6502(J.W++);
'    R->PC.B.h=Rd6502(J.W);
'  }
'}


END SUB

SUB IO.write (A%, B%)
END SUB

SUB M.ADC (A%)
IF REG.P AND D.FLAG THEN

K.B.l = (REG.A AND &HF) + (A% AND &HF) + (REG.P AND C.FLAG)
'    K.B.h=(R->A>>4)+(Rg>>4)+(K.B.l>15? 1:0); \

     tmp = 0: IF K.B.l > 15 THEN tmp = 1
K.B.h = (REG.A \ 2 ^ 4) + (A% \ 4) + tmp

IF K.B.l > 9 THEN K.B.l = K.B.l + 6: K.B.h = K.B.h + 1

 

     IF K.B.h > 9 THEN K.B.h = K.B.h + 6
    
     REG.A = (K.B.l AND &HF) OR (K.B.h * 2 ^ 4)


'    R->P=(R->P&~C_FLAG)|(K.B.h>15? C_FLAG:0); \
     tmp = 0: IF K.B.h > 15 THEN tmp = C.FLAG


     REG.P = (REG.P AND NOT (C.FLAG)) OR tmp
   ELSE

     K.W = REG.A + A% + (REG.P AND C.FLAG)

     REG.P = REG.P AND NOT (N.FLAG OR V.FLAG OR Z.FLAG OR c.dlag)


'    R->P|=(~(R->A^Rg)&(R->A^K.B.l)&0x80? V_FLAG:0)| \
     tmp = 0
     IF NOT (REG.A ^ A%) AND (REG.A ^ K.B.l) AND &H80 THEN tmp = V.FLAG
     REG.P = REG.P OR tmp
     tmp = 0
     IF K.B.h THEN tmp = C.FLAG
     REG.P = REG.P OR tmp OR zntable(K.B.l)


'          (K.B.h? C_FLAG:0)|ZNTable[K.B.l]; \
     REG.A = K.B.l
   END IF

END SUB

SUB M.ADCx (RG)
mx = adrRam(REG.X + zp)
  IF REG.P AND D.FLAG THEN
    K.B.l = (mx AND &HF) + (RG AND &HF) + (REG.P AND C.FLAG)
    K.B.h = (mx \ 2 ^ 4) + (RG \ 2 ^ 4)';/*+(K.B.l>>4);*/ \
    IF (K.B.l > 9) THEN K.B.l = K.B.l + 6: K.B.h = K.B.h + 1
    IF (K.B.h > 9) THEN K.B.h = K.B.h + 6
    mx = (K.B.l AND &HF) OR (K.B.h * 2 ^ 4)
    cycle = cycle + 1
  
  ELSE
  
    K.W = mx + RG + (REG.P AND C.FLAG)
                    mx = K.B.l
  END IF
  adrRam(REG.X + zp) = mx


 
END SUB

SUB M.AND (A%)
REG.A = REG.A AND A%
M.FL REG.A
END SUB

SUB M.ANDx (RG)
adrRam(REG.X + zp) = adrRam(REG.X + zp) AND RG
M.FL rdram(REG.X + zp)
END SUB

SUB m.asll (A%)
REG.P = REG.P AND NOT (C.FLAG)
REG.P = REG.P OR A% \ 2 ^ 7
A% = A% * 2 ^ 1
M.FL A%
END SUB

SUB M.BIT (A%)
REG.P = REG.P AND NOT (N.FLAG OR V.FLAG OR Z.FLAG)

'  R->P|=(Rg&(N_FLAG|V_FLAG))|(Rg&R->A? 0:Z_FLAG)
 tmp = 0: IF A% AND REG.A THEN tmp = Z.FLAG
REG.P = REG.P OR (A% AND (N.FLAG OR V.FLAG)) OR tmp


END SUB

SUB M.CMP (A%, B%)
   K.W = A% - B%

  REG.P = REG.P AND NOT (N.FLAG OR Z.FLAG OR C.FLAG)

  tmp = C.FLAG: IF K.B.h THEN tmp = 0
  REG.P = REG.P OR zntable(K.B.l) OR tmp


'  R->P&=~(N_FLAG|Z_FLAG|C_FLAG); \
'  R->P|=ZNTable[K.B.l]|(K.B.h? 0:C_FLAG)
END SUB

FUNCTION M.DEC (A%)
A% = A% - 1
M.FL A%
END FUNCTION

SUB M.EOR (A%)
REG.A = REG.A XOR A%
M.FL REG.A
END SUB

SUB M.EORx (RG)
adrRam(REG.X + zp) = adrRam(REG.X + zp) XOR RG
M.FL rdram(REG.X + zp)
END SUB

SUB M.FL (A%)
REG.P = (REG.P AND NOT (Z.FLAG OR N.FLAG)) OR zntable(A%)
END SUB

FUNCTION m.inc (A%)
A% = A% + 1
M.FL A%
END FUNCTION

DEFSNG A-Z
SUB M.JR ()
'#define M_JR        R->PC.W+=(offset)Op6502(R->PC.W)+1;R->ICount--
'error
' op6502 output to offset (signed char)
'reg.PC.W = reg.PC.W + (offset) * op6502(reg.PC.W) + 1

REG.PC.W = REG.PC.W + op6502(REG.PC.W) + 1
REG.icount = REG.icount - 1


END SUB

DEFINT A-Z
SUB M.LDWORD (A AS pcc)
A.B.l = op6502(REG.PC.W)
REG.PC.W = REG.PC.W + 1

A.B.h = op6502(r.pc.w)
REG.PC.W = REG.PC.W + 1
END SUB

SUB m.lsrr (A%)
REG.P = REG.P AND NOT (C.FLAG)
REG.P = REG.P OR (A% AND C.FLAG)
A% = A% \ 2 ^ 1
M.FL A%
END SUB

SUB M.ORA (A%)
REG.A = REG.A OR A%
M.FL REG.A
END SUB

SUB M.ORAx (RG)
adrRam(REG.X + zp) = adrRam(REG.X + zp) OR RG
M.FL rdram(REG.X + zp)
END SUB

DEFSNG A-Z
SUB M.POP (A AS INTEGER)
REG.s = REG.s + 1
A = op6502(&H100 OR REG.s)
END SUB

DEFINT A-Z
SUB M.PUSH (A%)
Wr6502 &H100 OR REG.s, A%
REG.s = REG.s - 1
END SUB

SUB M.RMB (A%)
END SUB

SUB m.roll (RG)
K.B.l = (RG * 2 ^ 1) OR (REG.P AND C.FLAG)
REG.P = REG.P AND NOT (C.FLAG)
REG.P = REG.P OR RG \ 2 ^ 7
RG = K.B.l
M_FL (RG)





END SUB

SUB m.rorr (RG)
K.B.l = (RG * 2 ^ 1) OR (REG.P * 2 ^ 7)
REG.P = REG.P AND NOT (C.FLAG)
REG.P = REG.P OR (RG AND C.FLAG)
RG = K.B.l
M_FL (RG)






END SUB

SUB M.SBC (A%)
'/* Warning! C_FLAG is inverted before SBC and after it */
'#define M_SBC(Rg) \
  IF (REG.P AND D.FLAG) THEN
    K.B.l = (REG.A AND &HF) - (RG AND &HF) - (NOT (REG.P) AND C.FLAG)
    IF (K.B.l AND &H10) THEN K.B.l = K.B.l - 6
    K.B.h = (REG.A \ 2 ^ 4) - (RG \ 2 ^ 4) - (K.B.l AND &H10)
    IF (K.B.h AND &H10) THEN K.B.h = K.B.h - 6
   REG.A = (K.B.l AND &HF) OR (K.B.h * 2 ^ 4)
   
   IF h.b.h > 15 THEN tmp = 0 ELSE tmp = C.FLAG
   REG.P = (REG.P AND NOT (C.FLAG)) OR tmp
  ELSE

    K.W = REG.A - RG - (NOT (REG.P) AND C.FLAG)
    REG.P = REG.P AND NOT (N.FLAG OR V.FLAG OR Z.FLAG OR C.FLAG)

    IF (REG.A XOR RG) AND (REG.A XOR K.B.l) AND &H80 THEN tmp = V.FLAG ELSE : tmp = 0

    REG.P = REG.P OR tmp
    IF K.B.h THEN tmp = 0 ELSE tmp = C.FLAG
    REG.P = REG.P OR tmp OR zntable(K.B.l)
    REG.A = K.B.l
END IF
END SUB

SUB M.SMB (A%)
END SUB

SUB mc.ab (A AS pcc)
M.LDWORD A
END SUB

SUB mc.ax (A AS pcc)
M.LDWORD A
A.W = A.W + REG.X
END SUB

SUB mc.ay (A AS pcc)
M.LDWORD A
A.W = A.W + REG.Y
END SUB

SUB mc.id (RG AS pcc)
K.W = MCZp()
RG.B.l = rdram(K.W): RG.B.h = rdram(K.W + 1)
END SUB

SUB mc.ix (RG AS pcc)
K.B.l = op6502(REG.PC.W) + REG.X: K.B.h = 0
REG.PC = REG.PC + 1
RG.B.l = op6502(K.W):
K.W = K.W + 1
RG.B.h = op6502(K.W)





END SUB

SUB mc.iy (RG AS pcc)

K.B.l = op6502(REG.PC.W) + REG.X: K.B.h = 0
REG.PC = REG.PC + 1
RG.B.l = op6502(K.W):
K.W = K.W + 1
RG.B.h = op6502(K.W)
RG.W = RG.W + REG.Y







END SUB

SUB mc.zp (RG AS pcc)
RG.B.l = op6502(REG.PC.W)
REG.PC.W = REG.PC.W + 1
RG.B.h = 0
END SUB

SUB mc.zx (RG AS pcc)
RG.B.l = op6502(REG.PC.W) + REG.X
REG.PC.W = REG.PC.W + 1
RG.B.h = 0
END SUB

SUB mc.zy (RG AS pcc)
RG.B.l = op6502(REG.PC.W) + REG.Y
REG.PC.W = REG.PC.W + 1
RG.B.h = 0
END SUB

FUNCTION MCZp ()
END FUNCTION

FUNCTION MCZx ()
END FUNCTION

SUB MM.Ab (A%)
'#define MM_Ab(Cmd)  MC_Ab(J);I=Rd6502(J.W);Cmd(I);Wr6502(J.W,I)
mc.ab j
I = rd6502(j.W)

'error
'cmd i
'error

Wr6502 j.W, I


END SUB

SUB mm.ax (A%)
'#define MM_Ax(Cmd)  MC_Ax(J);I=Rd6502(J.W);Cmd(I);Wr6502(J.W,I)
mc.ax j
I = rd6502(j.W)

'error
'cmd I
'

Wr6502 j.W, I

END SUB

SUB MM.Zp (A%)
'#define MM_Zp(Cmd)  MC_Zp(J);I=Rd6502(J.W);Cmd(I);Wr6502(J.W,I)
mc.zp j
I = rd6502(j.W)

'error
'cmd i

Wr6502 j.W, I


END SUB

SUB mm.zx (A%)
'#define MM_Zx(Cmd)  MC_Zx(J);I=Rd6502(J.W);Cmd(I);Wr6502(J.W,I)

mc.zx j
I = rd6502(j.W)

'error
'cmd i

Wr6502 j.W, I


END SUB

SUB MR.Ab (A%)
mc.ab j
A% = rd6502(j.W)
END SUB

SUB MR.Ax (A%)
mc.ax j
A% = rd6502(j.W)
END SUB

SUB MR.Ay (A%)
mc.ay j
A% = rd6502(j.W)
END SUB

SUB MR.Id (A%)
mc.id j
A% = rd6502(j.W)
END SUB

SUB MR.Im (A%)
A% = op6502(REG.PC.W)
REG.PC.W = REG.PC.W + 1
END SUB

SUB MR.Ix (A%)
mc.ix j
A% = rd6502(j.W)
END SUB

SUB MR.Iy (A%)
mc.iy j
A% = rd6502(j.W)



END SUB

SUB MR.Zp (A%)
mc.zp j
A% = rd6502(j.W)
END SUB

SUB MR.Zx (A%)
mc.zx j
A% = rd6502(j.W)
END SUB

SUB mr.zy (A%)
mc.zy j
A% = rd6502(j.W)
END SUB

SUB MW.Ab (A%)
mc.ab j
Wr6502 j.W, A%
END SUB

SUB MW.Ax (A%)
mc.ax j
Wr6502 j.W, A%
END SUB

SUB mw.ay (A%)
mc.ay j
Wr6502 j.W, A%
END SUB

SUB mw.ix (A%)
mc.ix j
Wr6502 j.W, A%
END SUB

SUB mw.iy (A%)
mc.iy j
Wr6502 j.W, A%
END SUB

SUB MW.Zp (A%)
mc.zp j
Wr6502 j.W, A%
END SUB

SUB MW.Zx (A%)
mc.zx j
Wr6502 j.W, A%
END SUB

SUB mw.zy (A%)
mc.zy j
Wr6502 j.W, A%
END SUB

DEFSNG A-Z
FUNCTION op6502 (A%)
'next opcode that a% points to
'extern byte *Page[];
'op6502 = Page(a \ 2 ^ 13)(a and &h1fff)



END FUNCTION

DEFINT A-Z
FUNCTION rd6502 (A%)
END FUNCTION

SUB reset6502 ()
'/** Reset6502() **********************************************/
'/** This function can be used to reset the registers before **/
'/** starting execution with Run6502(). It sets registers to **/
'/** their initial values.                                   **/
'/*************************************************************/
'void reset6502(M6502 * R)
'  R->A=R->X=R->Y=0x00;
REG.A = &H0
REG.X = &H0
REG.Y = &H0
REG.P = Z.FLAG OR r.flag
REG.s = &HFF
REG.PC.B.l = rd6502(&HFFFC)
REG.PC.B.h = rd6502(&HFFFD)
REG.icount = REG.iperiod
REG.irequest = int.none
REG.afterCLI = 0
END SUB

SUB run6502 ()
'/** Run6502() ************************************************/
'/** This function will run 6502 code until Loop6502() call  **/
'/** returns INT_QUIT. It will return the PC at which        **/
'/** emulation stopped, and current register values in R.    **/
'/*************************************************************/
'
'word run6502(M6502 * R)
'{
'  register pair J,K;
'  register byte I;
'
'  for(;;)
'  {
'#ifdef DEBUG
'    /* Turn tracing on when reached trap address */
'    if(R->PC.W==R->Trap) R->Trace=1;
'    /* Call single-step debugger, exit if requested */
'    if(R->Trace)
'      if(!Debug6502(R)) return(R->PC.W);
'#endif
'
'    I=Op6502(R->PC.W++);
'    R->ICount-=Cycles[I];
'    switch (I)
'    {
'#include "Codes.h"
'    }
'
'    /* If cycle counter expired... */
'    if(R->ICount<=0)
'    {
'      /* If we have come after CLI, get INT_? from IRequest */
'      /* Otherwise, get it from the loop handler            */
'      if(R->AfterCLI)
'      {
'        I=R->IRequest;            /* Get pending interrupt     */
'        R->ICount+=R->IBackup-1;  /* Restore the ICount        */
'        R->AfterCLI=0;            /* Done with AfterCLI state  */
'      }
'      ELSE
'      {
'        I=Loop6502(R);            /* Call the periodic handler */
'        R->ICount=R->IPeriod;     /* Reset the cycle counter   */
'      }
'
'      if(I==INT_QUIT) return(R->PC.W); /* Exit if INT_QUIT     */
'      if(I) Int6502(R,I);              /* Interrupt if needed  */
'    }
'  }
'
'  /* Execution stopped */
'  return(R->PC.W);
'}
END SUB

SUB T_INIT ()
END SUB

SUB Wr6502 (A%, B%)
END SUB

