int InitPCE(char *name,	char *backmemname)
{
	int i=0,ROMmask;
	unsigned long CRC;
	int dummy;

//	strupr(name);
//	cart_name = name;
	while ((cart_name[i]) && (short_cart_name[i++]=cart_name[i])!='.') ;


	if (CartLoad(name)) return -1;

	CRC=CRC_file(name); // I'm doing it only here 'coz cartload set name

	DMYROM=(BYTE *)malloc(0x2000);
	memset(DMYROM,NODATA,0x2000);
	WRAM=(BYTE *)malloc(0x2000);
	memset(WRAM,0,0x2000);
	VRAM=(BYTE *)malloc(VRAMSIZE);
	VRAM2=(unsigned	long *)malloc(VRAMSIZE);
	VRAMS=(unsigned	long *)malloc(VRAMSIZE);
	//memset(VRAM,0,VRAMSIZE);
	IOAREA=(BYTE *)malloc(0x2000);
	memset(IOAREA,0xFF,0x2000);
	vchange	= (BYTE	*)malloc(VRAMSIZE/32);
	memset(vchange,1,VRAMSIZE/32);
	vchanges = (BYTE *)malloc(VRAMSIZE/128);
	memset(vchanges,1,VRAMSIZE/128);
	ROMmask	= 1;
	while(ROMmask<ROM_size)	ROMmask<<=1;
	ROMmask--;
	fprintf(stderr,"ROMmask=%02X, ROM_size=%02X\n",	ROMmask, ROM_size);
	for(i=0;i<0xF7;i++)
	{
		if (ROM_size ==	0x30)
		{
			switch (i&0x70)
			{
			case 0x00:
			case 0x10:
			case 0x50:
				ROMMap[i]=ROM+(i&ROMmask)*0x2000;
				break;
			case 0x20:
			case 0x60:
				ROMMap[i]=ROM+((i-0x20)&ROMmask)*0x2000;
				break;
			case 0x30:
			case 0x70:
				ROMMap[i]=ROM+((i-0x10)&ROMmask)*0x2000;
				break;
			case 0x40:
				ROMMap[i]=ROM+((i-0x20)&ROMmask)*0x2000;
				break;
			}
		}
		else
			ROMMap[i]=ROM+(i&ROMmask)*0x2000;
	}
//		ROMMap[i]=ROM+(i%ROM_size+i/ROM_size*0x10)*0x2000;
/*		if (((i&ROMmask)+i/(ROMmask+1)) < ROM_size)
			ROMMap[i]=ROM+((i&ROMmask)+i/(ROMmask+1)*0x20)*0x2000;
		else
			ROMMap[i]=ROM;
*///		ROMMap[i]=ROM+(i&ROMmask)*0x2000;
	for (dummy=0;dummy<NB_ROM;dummy++)
	  if (CRC==ROM_LIST[dummy].CRC)
	     NO_ROM=dummy;
	if (NO_ROM!=0xFFFF)
	  fprintf(stderr,"ROM NAME : %s\n",ROM_LIST[NO_ROM].name);
	//if (populus)
	if ((NO_ROM==NO_POPULOUS1) || (NO_ROM==NO_POPULOUS2))
	{
		populus	= TRUE;
		fprintf(stderr,"POPULOUS DETECTED!!!\n");
		if (!(PopRAM=(byte*)malloc(PopRAMsize)))
		   perror("Not enough mem!");
		ROMMap[0x40] = PopRAM;
		ROMMap[0x41] = PopRAM +	0x2000;
		ROMMap[0x42] = PopRAM +	0x4000;
		ROMMap[0x43] = PopRAM +	0x6000;
	}
	else
	{
	  populus = FALSE;
	  PopRAM=NULL;
	}
/*	ROMMap[0x80] = PopRAM + (0)*0x2000;
	ROMMap[0x81] = PopRAM + (1)*0x2000;
	ROMMap[0x82] = PopRAM + (2)*0x2000;
	ROMMap[0x83] = PopRAM + (3)*0x2000;
	ROMMap[0x84] = PopRAM + (4)*0x2000;
	ROMMap[0x85] = PopRAM + (5)*0x2000;
	ROMMap[0x86] = PopRAM + (6)*0x2000;
	ROMMap[0x87] = PopRAM + (7)*0x2000;
*/	ROMMap[0xF7]=WRAM;
	ROMMap[0xF8]=RAM;
	ROMMap[0xF9]=RAM+0x2000;
	ROMMap[0xFA]=RAM+0x4000;
	ROMMap[0xFB]=RAM+0x6000;
	ROMMap[0xFF]=IOAREA; //NULL; /* NULL = I/O area */


	{
	FILE *fp;
	fp = fopen(backmemname,	"rb");
	if (fp == NULL)
		fprintf(stderr,"Can't open %s\n", backmemname);
	else
	  {
		fread(WRAM, 0x2000, 1, fp);
		fclose(fp);
	  }
	}

	return 0;
}
