byte IO_read(word A)
{
	byte ret;
	//printf("r%04x ",A&0x3FFF);
  switch(A&0x1C00){
  case 0x0000: /* VDC */
  	switch(A&3){
	case 0:
		ret = io.vdc_status;
		io.vdc_status=0;//&=VDC_InVBlank;//&=~VDC_BSY;
		return ret;
	case 1:
		return 0;
	case 2:
		if (io.vdc_reg==VRR)
			return VRAM[io.VDC[MARR].W*2];
		else return io.VDC[io.vdc_reg].B.l;
	case 3:
		if (io.vdc_reg==VRR) {
			ret = VRAM[io.VDC[MARR].W*2+1];
			io.VDC[MARR].W+=io.vdc_inc;
//			TRACE0("VRAM read\n");
			return ret;
		} else return io.VDC[io.vdc_reg].B.h;
	}
	break;

  case 0x0400:/* VCE */
  	switch(A&7){
	case 4:	return io.VCE[io.vce_reg.W].B.l;
	case 5:	return io.VCE[io.vce_reg.W++].B.h;
	}
	break;
#ifndef	FINAL_RELEASE
  case 0x0800:	/* PSG */
	switch(A&15){
	case 0:	return io.psg_ch;
	case 1:	return io.psg_volume;
	case 2:	return io.PSG[io.psg_ch][2];
	case 3:	return io.PSG[io.psg_ch][3];
	case 4:	return io.PSG[io.psg_ch][4];
	case 5:	return io.PSG[io.psg_ch][5];
	case 6:
		{
			//int	ofs=io.wavofs[io.psg_ch];
			//io.wavofs[io.psg_ch]=(io.wavofs[io.psg_ch]+1)&31;
			//return io.wave[io.psg_ch][ofs];
			int ofs=fixtoi(snd_pos[io.psg_ch]);
			snd_pos[io.psg_ch]=itofix((fixtoi(snd_pos[io.psg_ch])+1)&31);
			return io.wave[io.psg_ch][ofs];

		}
	case 7:	return io.PSG[io.psg_ch][7];
	case 8:	return io.psg_lfo_freq;
	case 9:	return io.psg_lfo_ctrl;
	default: return	NODATA;
	}
	break;
#endif
  case 0x0c00:	/* timer */
	return io.timer_counter;

  case 0x1000:	/* joypad */
//	  TRACE("js=%d\n", io.joy_counter);
		ret = io.JOY[io.joy_counter]^0xff;
		if (io.joy_select&1) ret>>=4;
		else { ret&=15;	io.joy_counter=(io.joy_counter+1)%5; }
		return ret|Country; /* country 0:JPN 1=US */

  case 0x1400:	/* IRQ */
	switch(A&15){
	case 2:	return io.irq_mask;
	case 3:	ret = io.irq_status;io.irq_status=0;return ret;
	}
	break;

  case 0x1800:	/* CD-ROM extention */
	switch(A&15){
	case 3:	return io.backup = DISABLE;
//	case 0xa: 
//		if (!io.adpcm_firstread) return PCM[io.adpcm_rptr++];
//		else {io.adpcm_firstread=FALSE; return NODATA;}
	}
	break;
  }
#ifndef	FINAL_RELEASE
	fprintf(stderr,"ignore I/O read %04x\n",A);
#endif
//	DebugDumpFp(4, TRUE);
	return NODATA;
}
